#include "MainWindow.h"
#include "ui_MainWindow.h"

#include "math.h"
#include <QFile>
#include <QFileDialog>
#include <QTextStream>
#include <QGraphicsView>
#include <QPixmap>
#include <QGraphicsPixmapItem>
#include <QGraphicsEllipseItem>
#include <QList>
#include <QTimer>
#include <QLine>
#include <QProcess>
#include <QDebug>
#include <QMessageBox>

//#include <QSound>
#include <QtMultimedia/QMediaPlayer>
#include <QAudioOutput>

#include <QMouseEvent>
#include <QScrollBar>


QString version_i = "v18.2";

QFile file_dat;

uint16_t largeur_image = 1216; // image du manche de la guitare
uint16_t hauteur_image = 180;

QDir currentDir;
QString base_Dir;
QString default_Dir = "/home/";
QString string_currentDir = default_Dir; // à priori; sera mis à jour lors de la lecture du fichier 'params.ini'
QString string_currentFile;

QString repertoire_images;
QString nom_fichier_in="";
QStringList liste_str_in;
QStringList liste_accords;

QDataStream binStream1;

//QList<NOTE> liste_notes;
//QList<MESURE> liste_mesures;

QList<uint16_t> positionsX;
QList<QString> noms_notes;
QList<QString> gamme_chromatique;
QList<QString> gamme_chromatique_GB;
//QList<QColor> liste_couleurs;
QList<QString> liste_couleurs;
QList<NOTE_importee> liste_NOTES_importees;

int type_accords=0; // 1=MAJ; 2=min; 3=7e dom

uint16_t x_clic_ecran, y_clic_ecran;

int nb_lignes;
int L_save_min=0;
int L_save_max=0;
int numero_note=0; // dans la liste totale de la partition (ne compte QUE les notes)
int num_ligne_en_cours=0; // lignes du tableWidget_3
int num_note_A=0;
int num_note_max=0;
int num_note_stop=10000;
int nb_notes_jouees_max;
int nb_notes_jouees=0;
int accord_en_cours=0;
int num_note_jouee=0;
int corde_jouee;
int case_jouee;
int n_midi_jouee;
int ligne_TW3;
int memo_corde_i;
int memo_case_i;
QString acc1="";
QString memo_acc1="";
char gamme;

int case_min=0;
int case_max=0;

int mesure_a_encadrer=0;
int memo_mesure_a_encadrer=0;
int num_colonne_a_encadrer=0;
int nb_colonnes_a_encadrer=1;
int zoom=1;

int num_mesure_en_cours=0;

int Tp1;
int temps1;

float duree=30;
int boucler=0;
int lecture_pause=1; // fonction du bouton lecture / pause
int n_player=1;

double grille_t0;
double grille_dt;

bool notes_pleines; // concerne le graphique : ellipse pleine ou bien juste un cercle
bool notes_silencieuses; // pour représenter les positions d'accords, sans les jouer
bool mode_depot_note=false; // pour écrire la valeur midi d'une note dans TW3 suite à clic de droite le manche
bool data_ok = false;
bool dossier_de_travail_ok = false;



MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent)
{
    setupUi(this);
    setWindowTitle("Guitare " + version_i);

    //this->setGeometry(0,0, 1900, 1000);
    setWindowState(Qt::WindowMaximized);

    //statusbar->showMessage("Position des doigts...");

    frame_back->setGeometry(0, 0, 1900, 1050);

    scene1 = new QGraphicsScene(this);

    graphicsView1->setScene(scene1);
    graphicsView1->setGeometry(10,100, largeur_image+20, hauteur_image+5);
    pushButton_8->setGeometry(10, 100, 26, 26); // bouton aide1 (sur le manche)
    pushButton_9->setGeometry(38, 100, 26, 26); // bouton aide2 (sur le manche)

    Timer2 = new QTimer(this);

    connect(Timer2, SIGNAL(timeout()), this, SLOT(Tic2()));
    connect(tableWidget_T->horizontalScrollBar(), SIGNAL(valueChanged(int)), this, SLOT(TW_T_scroll(int)));
    connect(tableWidget_3->verticalScrollBar(), SIGNAL(valueChanged(int)), this, SLOT(TW_3_scroll(int)));

    repertoire_images = "./images/"; // chemin relatif / dossier de l'exécutable
    charger_image_manche();

    calque_notes = new QGraphicsItemGroup();
    scene1->addItem(calque_notes);

    calque_encadrement = new QGraphicsItemGroup();
    scene1->addItem(calque_encadrement);

    Frame_wWidget1 = new QFrame();

    positionsX << 5 << 55 << 140 <<225 << 305 << 385 << 459 << 528 << 595 << 650 << 714 << 765
     << 820 << 864 << 910 << 960 << 1000 << 1035 << 1072 << 1111 << 1145;
    // 21 valeurs en comptant les cordes à vide
    // indice max = 21-1 = 20

    player1 = new QMediaPlayer;
    audioOutput1 = new QAudioOutput(this);
    player1->setAudioOutput(audioOutput1);

    player2 = new QMediaPlayer;
    audioOutput2 = new QAudioOutput(this);
    player2->setAudioOutput(audioOutput2);

    player3 = new QMediaPlayer;
    audioOutput3 = new QAudioOutput(this);
    player3->setAudioOutput(audioOutput3);

    player4 = new QMediaPlayer;
    audioOutput4 = new QAudioOutput(this);
    player4->setAudioOutput(audioOutput4);

    player5 = new QMediaPlayer;
    audioOutput5 = new QAudioOutput(this);
    player5->setAudioOutput(audioOutput5);

    player6 = new QMediaPlayer;
    audioOutput6 = new QAudioOutput(this);
    player6->setAudioOutput(audioOutput6);

    player7 = new QMediaPlayer;
    audioOutput7 = new QAudioOutput(this);
    player7->setAudioOutput(audioOutput7);

    player8 = new QMediaPlayer;
    audioOutput8 = new QAudioOutput(this);
    player8->setAudioOutput(audioOutput8);

    noms_notes<<"La"<<"Si"<<"Do"<<"Ré"<<"Mi" <<"Fa"<<"Sol";  // <- A B C D E F G
    gamme_chromatique<<"Do"<<"Do#"<<"Ré"<<"Mib"<<"Mi"<<"Fa"<<"Fa#"<<"Sol"<<"Sol#"<<"La"<<"Sib"<<"Si";
    gamme_chromatique_GB<<"C"<<"C#"<<"D"<<"Eb"<<"E"<<"F"<<"F#"<<"G"<<"G#"<<"A"<<"A#"<<"B";

    liste_couleurs <<"#EF2929"<<"#FF5C00"<<"#FCAF3E"<<"#FFE300"<<"#BFFF00"<<"#07F64F"
    <<"#16D298"<<"#16D2C4"<<"#00AEFF"<<"#1667D2"<<"#7C00FF"<<"#FF67EF"<<"#EEEEEC"; //(la dernière = GRIS)

    lecture_fichier_ini();

    //init_TW_1();
    init_TW_3();
    init_TW_T();
    init_TAB_lst_notes();
    init_tableWidget_doigts();
    init_autres();

    on_spinBox_2_valueChanged(0);

    doubleSpinBox_vitesse->setValue(8.0);
    //on_doubleSpinBox_vitesse_valueChanged(30);

    radioButton_Z1->setChecked(true); // set zomm 1
    set_zoom1();

    Bt_lecture_2->setText("joue > debut");
    notes_pleines = true;
    notes_silencieuses = false;

    on_pushButton_3_clicked();
    effacer_calque(scene1, calque_encadrement);
    label_43->clear();
    label_44->clear();
    label_45->clear();
    //line1 = new QFrame(this);
    Frame_wWidget1->setVisible(false);

}

MainWindow::~MainWindow()
{
    delete ui;
}


void MainWindow::save_fichier_ini()
{
    QFile file1(QDir::currentPath() + "/" + "params_Guitare.ini"); // dans le dossier de l'exécutable
    if (file1.open(QIODevice::WriteOnly | QIODevice::Text))
    {
        //int p1= string_currentFile.lastIndexOf('/');
       // string_currentDir = string_currentFile.left(p1);

        QTextStream out(&file1);

        out << "# Ce fichier est cree automatiquement par le programme";
        out << '\n';
        out << "#";
        out << '\n';
        out << "# chemins:";
        out << '\n';
        out << "<currentDir>" << string_currentDir << "</currentDir>";
        out << '\n';
        out << "<currentFile>" << string_currentFile << "</currentFile>";
    }
    file1.close();
}


void MainWindow::lecture_fichier_ini()
{
    //QMessageBox msgBox;
    QString line;
    int p1, p2, p3;

    dossier_de_travail_ok = false; // à priori
    QFile file1(QDir::currentPath() + "/" + "params_Guitare.ini"); // dans le dossier de l'exécutable (= QDir::currentPath() )
    if (file1.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        QTextStream in(&file1);
        in.reset();
        while ( !in.atEnd() )
        {
            line = in.readLine();
            if (line.at(0) !='#')
            {
                if ((p1 = line.indexOf("<currentDir>")) != -1)
                {
                    p2 = line.indexOf('>',p1);
                    p3 = line.indexOf("</",p2);
                    QString s1 = line.mid(p2+1, p3-p2-1);
                    string_currentDir = s1;

                    dossier_de_travail_ok = true;
                }


                if ((p1 = line.indexOf("<currentFile>")) != -1)
                {
                    p2 = line.indexOf('>',p1);
                    p3 = line.indexOf("</",p2);
                    QString s1 = line.mid(p2+1, p3-p2-1);
                    string_currentFile = s1;
                }
            }
        }
        file1.close();
    }
    else
    {
        QString s1 = "fichier .ini non trouvé, je le crée (dans le dossier de l'executable)";
        QMessageBox msgBox;   msgBox.setText(s1);  msgBox.exec();
        base_Dir=QDir::currentPath() + "/";
        save_fichier_ini();
        dossier_de_travail_ok = false;
    }

    lineEdit_current_dir->setText(string_currentDir);
}


float freq_mid(int midi_i) // calcule la fréquence (en Hertz) d'une note à partir de son numéro midi
{
// https://fr.wikipedia.org/wiki/MIDI_Tuning_Standard
    float F, A;
    A=((float)midi_i-69.0)/12.0;
    F= 440 * powf(2,A);
    return F;
}


void MainWindow::init_TW_3() // affi grande liste verticale
{

    label_TW3->setGeometry(1205, 10, 50, 18);
    tableWidget_3->setGeometry(1250, 10, 640, 836); // la valeur 836 est critique pour l'encadrement ok
    tableWidget_3->clear();
    tableWidget_3->setRowCount(1);
    tableWidget_3->setColumnCount(12);
    QStringList liste_entetes;
    liste_entetes <<"note1"<<"note2"<<"note3"<<"Cmt"<<">"<<"dur"<<"M"<<"tps"<< "n°b"<<"ACC"<<"cases"<<"doigts";
    tableWidget_3->setHorizontalHeaderLabels (liste_entetes );
    tableWidget_3->resizeColumnsToContents();
    //for(int n=0; n<=2; n++)
    {
        tableWidget_3->setItem(0, 0, new QTableWidgetItem (" ") ); tableWidget_3->setColumnWidth(0,65);
        tableWidget_3->setItem(0, 1, new QTableWidgetItem (" ") ); tableWidget_3->setColumnWidth(1,65);
        tableWidget_3->setItem(0, 2, new QTableWidgetItem (" ") ); tableWidget_3->setColumnWidth(2,65);

        tableWidget_3->setItem(0, 3, new QTableWidgetItem (" ") ); tableWidget_3->setColumnWidth(3,100); // commentaire
        tableWidget_3->setColumnWidth(3, 80);

        QTableWidgetItem *Item1 = new QTableWidgetItem();
        Item1->setIcon(QIcon("../images/01.png" ));
        tableWidget_3->setItem(0, 4, Item1 );
        tableWidget_3->setColumnWidth(4, 20);

        tableWidget_3->setItem(0, 5, new QTableWidgetItem ("0") ); // durée
        tableWidget_3->setColumnWidth(5, 40);

        tableWidget_3->setItem(0, 6, new QTableWidgetItem ("0") ); // MESURE
        tableWidget_3->setColumnWidth(6, 40);

        tableWidget_3->setItem(0, 7, new QTableWidgetItem (" ") ); // tps
        tableWidget_3->setColumnWidth(7, 40);

        tableWidget_3->setItem(0, 8, new QTableWidgetItem (" ") ); // tot
        tableWidget_3->setColumnWidth(8, 40);

        tableWidget_3->setItem(0, 9, new QTableWidgetItem (" ") ); // ACC
        tableWidget_3->setColumnWidth(9, 54);

        tableWidget_3->setItem(0, 10, new QTableWidgetItem (" ") ); // cases
        tableWidget_3->setColumnWidth(10, 52);

        tableWidget_3->setItem(0, 11, new QTableWidgetItem (" ") ); // doigts
        tableWidget_3->setColumnWidth(11, 60);

    }
}

void MainWindow::init_tableWidget_doigts()
{
    tableWidget_doigts->setGeometry(5, 20, 200, 200);

    tableWidget_doigts->clear();
    tableWidget_doigts->setRowCount(5);
    tableWidget_doigts->setColumnCount(3);
    QStringList liste_entetesH;
    liste_entetesH <<"corde"<<"case"<<"DOIGT";
    tableWidget_doigts->setHorizontalHeaderLabels (liste_entetesH );

    QStringList liste_entetesV;
    liste_entetesV <<"0"<<"1"<<"2"<<"3"<<"4";
    tableWidget_doigts->setVerticalHeaderLabels(liste_entetesV );

    for(int n=0; n<5; n++)
    {
        QTableWidgetItem *Item1 = new QTableWidgetItem();
        Item1->setIcon(QIcon("../images/02.png" ));
        tableWidget_doigts->setItem(n, 2, Item1 );
    }
    tableWidget_doigts->resizeColumnsToContents();
    tableWidget_doigts->setColumnWidth(2, 20);

    pushButton_6->setGeometry(189, 0, 22, 21); // bouton aide position des doigts

    Bt_copie_doigts_to_TW3->setGeometry(50, 147, 150, 26);
    Bt_RAZ_doigts->setGeometry(10, 147, 31, 26);


    int R, C;
    for (R=0; R<5; R++)
    {
        for (C=0; C<2; C++)
        {
            tableWidget_doigts->setItem(R, C, new QTableWidgetItem ("-") );
            tableWidget_doigts->item(R,C)->setTextAlignment(Qt::AlignCenter);
        }
    }
}



void MainWindow::init_TW_T()
{
    tableWidget_T->setGeometry(10, 880, 1870, 135);
    tableWidget_T->setColumnCount(300);
    label_timeline->setGeometry(10, 850, 100, 30);

    tableWidget_T->clear();
    for(int n=0; n< tableWidget_T->columnCount(); n++)
    {
        complete_case(0, n, "-", "#000000", "#FFFFFF", false, tableWidget_T);
        //complete_case(5, n, "-", "#000000", "#FFFFFF", tableWidget_T);
    }

}


void MainWindow::init_TAB_lst_notes()
{
    tableWidget_lst_notes->setGeometry(140,640,450,231);
    QStringList liste_entetes1;
    liste_entetes1<<"numéro"<<"midi"<<"note"<<"n° barre"<< "temps"<< "durée" << " ";
    tableWidget_lst_notes->setHorizontalHeaderLabels (liste_entetes1);
    tableWidget_lst_notes->setEditTriggers(QAbstractItemView::NoEditTriggers);

}




void MainWindow::init_autres()
{
    groupBox_1->setGeometry(20, 450, 350, 181);   // Configurateur d'Accords
    groupBox_2->setGeometry(900, 490, 311, 370);
    groupBox_3->setGeometry(670, 450, 200, 180);  // Général
    groupBox_4->setGeometry(380, 450, 210, 180);  // Position des doigts

    groupBox_ZOOM->setGeometry(20, 760, 50, 70);

    H_line_1->setVisible(false);
    V_line_1->setVisible(false);
    H_line_2->setVisible(false);
    V_line_2->setVisible(false);
    H_line_1b->setVisible(false);
    V_line_1b->setVisible(false);
    H_line_2b->setVisible(false);
    V_line_2b->setVisible(false);

    label_44->setGeometry(900, 430, 111, 31);
    label_45->setGeometry(900, 450, 111, 31);

    groupBox_Import->setGeometry(600, 640, 270, 100);
    pushButton_11->setGeometry(560, 640, 31, 26);

    groupBox_sigles->setGeometry(600, 750, 270, 121);

    Bt_save_ACD->setGeometry(1000, 50, 92, 26);
    Bt_load_ACD->setGeometry(1100, 50, 92, 26);


    create_100_lignes_V();
}


void MainWindow::effacer_calque(QGraphicsScene *scene_i, QGraphicsItemGroup *calque_i)
{
    foreach( QGraphicsItem *item, scene_i->items( calque_i->boundingRect() ) )
    {if( item->group() == calque_i )  { delete item; }}
}



void MainWindow::charger_image_manche()
{
    QString fileName1;
    fileName1 = repertoire_images + "manche2.jpg";

    QFile file1(fileName1);
    if (file1.exists() )
    {
        QImage image1(fileName1);
        image1 = image1.scaledToWidth(largeur_image);
        image1.load(fileName1);
        //imageLabel1->setPixmap(QPixmap::fromImage(image1));
        QGraphicsPixmapItem* item1 = new QGraphicsPixmapItem(QPixmap::fromImage(image1));
        scene1->addItem(item1);
        //calque_notes->addToGroup(item1);
    }
}


void MainWindow::affi_txt_en_couleur(int midi_i, QLineEdit *lineEdit_i)
{
    int h1 = calcul_hauteur_note(midi_i); h1-=3; if(h1<0){h1+=12;} if(h1>11){h1-=12;}
    if ((h1<0) || (h1>(liste_couleurs.length()-1))) {h1 = 0;}
    QString c1 = liste_couleurs[h1];
    QString c2 = "#000000";
    lineEdit_i->setStyleSheet("color: " + c1 + "; background-color: " + c2 + "; font: 700 14pt 'Ubuntu';");
}


QString MainWindow::nom_note_FR(int mid)
{
    QString s1;

    int h1 = calcul_hauteur_note(mid);
    h1-=3;
    if(h1<0){h1+=12;}
    if(h1>11){h1-=12;}

    if((h1<0) || ( h1>= gamme_chromatique.length())) {return "-";}
    s1 = gamme_chromatique[h1];
    return s1;
}


QString MainWindow::nom_note_GB(int mid)
{
    QString s1;

    int h1 = calcul_hauteur_note(mid);
    h1-=3;
    if(h1<0){h1+=12;}
    if(h1>11){h1-=12;}

    if((h1<0) || ( h1>= gamme_chromatique_GB.length())) {return "-";}
    s1 = gamme_chromatique_GB[h1];
    return s1;
}


QString MainWindow::nom_octave_GB(int mid)
{
    QString octave;
    if((mid>=40)&&(mid < 48)) {octave = "2";}
    if((mid>=48)&&(mid < 60)) {octave = "3";}
    if((mid>=60)&&(mid < 72)) {octave = "4";}
    if((mid>=72)&&(mid < 90)) {octave = "5";}
    return octave;
}

int MainWindow::calcul_hauteur_note(int mid) //, char *nom_GB)
{
    //40 E3 (mi octave 2)

    int h1;
    QString s0, s1 , s2, s3, s4;
    h1 = mid-40;
    h1 -=5;  // -5
    h1+=12;
    gamme=2;
    while(h1>=12)
    {
        h1-=12;
        gamme++;
    }
    if (h1==12) {h1=0;}

    if (h1==0) {s2="A"; s3="La";}
    if (h1==1) {s2="Bb"; s3="Sib";}
    if (h1==2) {s2="B"; s3="Si";}
    if (h1==3) {s2="C"; s3="D0";}
    if (h1==4) {s2="C#"; s3="D0#";}
    if (h1==5) {s2="D"; s3="Re";}
    if (h1==6) {s2="Eb"; s3="Mib";}
    if (h1==7) {s2="E"; s3="Mi";}
    if (h1==8) {s2="F"; s3="Fa";}
    if (h1==9) {s2="F#"; s3="Fa#";}
    if (h1==10) {s2="G"; s3="Sol";}
    if (h1==11) {s2="G#"; s3="Lab";}


    s1.setNum(h1);
    s4.setNum(gamme);

    s0=s2 + s4 + " (" +s3 +s4 + ")";

    lineEdit_note->setText(s0);

    return h1; // h1 = 0..11
}


int MainWindow::calcul_midi(int corde_i, int case_i)
{
 //   40 -> Mi octave 2 (corde 6 à vide)
    int n;
    n = 40 + case_i;            //  corde6  de Mi grave
    if (corde_i == 5){n+=5;}
    if (corde_i == 4){n+=10;}
    if (corde_i == 3){n+=15;}
    if (corde_i == 2){n+=19;}
    if (corde_i == 1){n+=24;}   // corde1  de Mi aigu (+2 octaves)

    //*n_midi = n;
    return n;

}


void MainWindow::calcul_xy_note(int corde_i, int case_i, int *x_i, int *y_i)
{
    float x;
    float y;
    float dy;
    float y0;
    float ech;

    if (case_i >= positionsX.length())
    {
        *x_i=1;
        *y_i=1;
        return;
    }
    x=positionsX[case_i];

    y0=102;
    ech=1+case_i/90.0;
    dy=-20.0*((7-corde_i)-3.2);

    dy *= ech;
    y=y0+dy;

    *x_i=int(x);
    *y_i=int(y);
}



void MainWindow::detecte_note_xy(int x_i, int y_i, int *corde_i, int *case_i)
{
// suite à un clic directement sur le manche
// voir la fonction "mousePressEvent()"
    float y;
    float dy;
    float y0;
    float ech;

// détection du numéro de la case jouée
    *case_i=-1;
    for (int i=0; i<21; i++)
    {
        int x= positionsX[i] +30;
        if ((abs(x_i - x))<30) {*case_i = i;}
    }
    if (*case_i == -1)
    {
        *corde_i=0;
        *case_i=0;
        return;
    }

// détection du numéro de la corde jouée
    *corde_i=0;
     y0=220;

    for (int i=1; i<=6; i++)
    {
        ech=1+ *case_i/90.0;
        dy=-20.0*((7-i)-3.2);
        dy *= ech;
        y=y0+dy;

        if ((abs(y_i - y))<20) {*corde_i = i;}
    }
}


void MainWindow::numerote_1_note(int corde_i, int case_i, int num_i)
{
    QString s1;
    int x, y;

    s1.setNum(num_i);

    calcul_xy_note(corde_i, case_i, &x, &y);
    textItem1 = new QGraphicsSimpleTextItem(s1);
    QBrush brush1;
    brush1.setStyle(Qt::SolidPattern);
    brush1.setColor("#000000");
    textItem1->setBrush(brush1);
    textItem1->setPos(x+2, y -1);
    calque_notes->addToGroup(textItem1);
}



void MainWindow::dessine_1_note(int corde_i, int case_i, QColor couleur_i)
{
    int x, y;
// case_i = 0..20   (0 -> corde à vide)

    if ( (case_i < case_min) || (case_i > case_max) ) {return;}

    uint midi = calcul_midi(corde_i, case_i);
    affiche_details_note(midi);

    QPen pen_note(couleur_i, 1, Qt::SolidLine);

    if ((case_i>=0) && (case_i<=20))
    {
        calcul_xy_note(corde_i, case_i, &x, &y);
        ellipse1 = new 	QGraphicsEllipseItem(x, y, 15, 15);
        ellipse1->setPen(pen_note);
        if (notes_pleines == true) {ellipse1->setBrush(couleur_i);}
        calque_notes->addToGroup(ellipse1);

        memo_case_i=case_i;
        memo_corde_i=corde_i;
    }
}


void MainWindow::encadre_accord(int case1, int case2)
{
    int x0, y0, x1, y1, dx, dy;

    effacer_calque(scene1, calque_encadrement);

    if (case1>19) {return;}
    if (case2>20) {return;}

    if (case1>case2) {return;}

qDebug() << "case1" << case1;
qDebug() << "case2" << case2;
qDebug() << "______________";

    calcul_xy_note(1, case1, &x0, &y0);
    calcul_xy_note(6, case2, &x1, &y1);
    dx= x1-x0;
    dy=y1-y0;

    Frame_wWidget1->setGeometry(QRect(x0-4, y0-2, dx+24, dy +14));
    Frame_wWidget1->setStyleSheet( "background: transparent;" "border: 1px solid yellow;" "border-radius: 15px;" );
    QGraphicsProxyWidget *proxy = scene1->addWidget(Frame_wWidget1);
    Frame_wWidget1->setVisible(true);
}


void MainWindow::dessine_accord(int corde_i1, int case_i1, int corde_i2, int case_i2)
{
//QGraphicsLineItem *QGraphicsScene::addLine(qreal x1, qreal y1, qreal x2, qreal y2, const QPen &pen = QPen())
    int x1, y1;
    int x2, y2;
    QString couleur1;
    calcul_xy_note(corde_i1, case_i1, &x1, &y1);
    calcul_xy_note(corde_i2, case_i2, &x2, &y2);
    couleur1 = liste_couleurs[4];
    QPen pen_ligne; //(liste_couleurs[4], 1, Qt::SolidLine);
    pen_ligne.setColor(couleur1);
    scene1->addLine(x1+8, y1+8, x2+8, y2+8, pen_ligne);
}





/**
REMARQUES:

pour la guitare :
E2 = le Mi2 grave (corde 6 à vide)
E3 = le Mi3 corde 4 case 2
E4 = le Mi4 corde 1 à vide
E5 = le Mi5 corde 1 case 12
D6 = le Ré6 corde 1 case 22 (la note la plus aigüe de la guitare électrique)

donc au total (presque) 4 octaves (manque juste 2 notes, Mib6 et Mi6)
**/


void MainWindow::execute_note_midi(uint midi)
{
    calcul_hauteur_note(midi);
    //if (checkBox1->isChecked()) {on_Bt_RAZ_clicked();} // efface tout avant de ne dessiner qu'une seule note
    //QString s1;
    //s1.setNum(i);
    //lineEdit_7->setText(s1);
    num_note_jouee++;
    switch(midi)
    {
        case 40: on_Bt_E3_clicked(); break; // mi octave 3
        case 41: on_Bt_F3_clicked(); break; // fa octave 3
        case 42: on_Bt_Fd3_clicked(); break; // fa# octave 3
        case 43: on_Bt_G3_clicked(); break; //sol
        case 44: on_Bt_Gd3_clicked(); break; //sol#
        case 45: on_Bt_A3_clicked(); break; //la
        case 46: on_Bt_Bb3_clicked(); break; //sib
        case 47: on_BT_B3_clicked(); break; //si
        case 48: on_Bt_C4_clicked(); break; //do
        case 49: on_Bt_Cd4_clicked(); break; //do#
        case 50: on_Bt_D4_clicked(); break; //re
        case 51: on_Bt_Eb4_clicked(); break; //mib
        case 52: on_Bt_E4_clicked(); break; //mi
        case 53: on_Bt_F4_clicked(); break; //fa
        case 54: on_Bt_Fd4_clicked(); break; //fa#
        case 55: on_Bt_G4_clicked(); break; //sol
        case 56: on_Bt_Gd4_clicked(); break; //sol#
        case 57: on_Bt_A4_clicked(); break; //la
        case 58: on_Bt_Bb4_clicked(); break; //sib
        case 59: on_Bt_B4_clicked(); break; //si
        case 60: on_Bt_C5_clicked(); break; //do
        case 61: on_Bt_Cd5_clicked(); break; //do#
        case 62: on_Bt_D5_clicked(); break; //re
        case 63: on_Bt_Eb5_clicked(); break; //mib
        case 64: on_Bt_E5_clicked(); break; //mi
        case 65: on_Bt_F5_clicked(); break; //fa
        case 66: on_Bt_Fd5_clicked(); break; //fa#
        case 67: on_Bt_G5_clicked(); break; //sol
        case 68: on_Bt_Gd5_clicked(); break; //sol#
        case 69: on_Bt_A5_clicked(); break; //la
        case 70: on_Bt_Bb5_clicked(); break; //sib
        case 71: on_Bt_B5_clicked(); break; //si
        case 72: on_Bt_C6_clicked(); break; //do
        case 73: on_Bt_Cd6_clicked(); break; //do#
        case 74: on_Bt_D6_clicked(); break; //re
        case 75: on_Bt_Eb6_clicked(); break; //mib
        case 76: on_Bt_E6_clicked(); break; //mi
        case 77: on_Bt_F6_clicked(); break; //fa
        case 78: on_Bt_Fd6_clicked(); break; //fa#
        case 79: on_Bt_G6_clicked(); break; //sol
        case 80: on_Bt_Gd6_clicked(); break; //sol#
        case 81: on_Bt_A6_clicked(); break; //la
        case 82: on_Bt_Bb6_clicked(); break; //sib

        default: { ; } break;
    }
}

 /*
A TRAITER: silences (rest)

voir fichier xml ligne 535
  *
<note>
  <rest/>
  <duration>12</duration>
  <voice>1</voice>
  <type>eighth</type>
  <staff>1</staff>
</note>
*/


void MainWindow::effacer_touches()
{
    QColor c = "#505050";
    set_couleur_label(c, label5);
    set_couleur_label(c, label6);
    set_couleur_label(c, label7);
    set_couleur_label(c, label8);
    set_couleur_label(c, label9);
    set_couleur_label(c, label10);
    set_couleur_label(c, label11);
    set_couleur_label(c, label12);

    set_couleur_label(c, label1_2);
    set_couleur_label(c, label2_2);
    set_couleur_label(c, label3_2);
    set_couleur_label(c, label4_2);
    set_couleur_label(c, label5_2);
    set_couleur_label(c, label6_2);
    set_couleur_label(c, label7_2);
    set_couleur_label(c, label8_2);
    set_couleur_label(c, label9_2);
    set_couleur_label(c, label10_2);
    set_couleur_label(c, label11_2);
    set_couleur_label(c, label12_2);

    set_couleur_label(c, label1_3);
    set_couleur_label(c, label2_3);
    set_couleur_label(c, label3_3);
    set_couleur_label(c, label4_3);
    set_couleur_label(c, label5_3);
    set_couleur_label(c, label6_3);
    set_couleur_label(c, label7_3);
    set_couleur_label(c, label8_3);
    set_couleur_label(c, label9_3);
    set_couleur_label(c, label10_3);
    set_couleur_label(c, label11_3);
    set_couleur_label(c, label12_3);

    set_couleur_label(c, label1_4);
    set_couleur_label(c, label2_4);
    set_couleur_label(c, label3_4);
    set_couleur_label(c, label4_4);
    set_couleur_label(c, label5_4);
    set_couleur_label(c, label6_4);
    set_couleur_label(c, label7_4);
    set_couleur_label(c, label8_4);
    set_couleur_label(c, label9_4);
    set_couleur_label(c, label10_4);
    set_couleur_label(c, label11_4);
    set_couleur_label(c, label12_4);

}


void MainWindow::on_Bt_RAZ_clicked()
{
 // sur le manche
    effacer_calque(scene1, calque_notes);
    effacer_calque(scene1, calque_encadrement);
    Frame_wWidget1->setVisible(false);

// la suite sur les touches
    effacer_touches();

   // label_44->setText("-");
   // label_45->setText("-");

}


void MainWindow::set_couleur_bouton(QColor c1, QPushButton *Bt_i)
{
    QPalette pal1 = Bt_i->palette();
    pal1.setColor(QPalette::Button, c1);
    Bt_i->setPalette(pal1);
}


void MainWindow::set_couleur_label(QColor c1, QLabel *Lb_i)
{
    QPalette pal1 = Lb_i->palette();
    pal1.setColor(Lb_i->backgroundRole(), c1);
    Lb_i->setAutoFillBackground(true);
    Lb_i->setPalette(pal1);
}


void MainWindow::set_couleur_case(QColor couleur_i, QTableWidget *Tb_i, int L, int C)
{
    QTableWidgetItem *Item1 = new QTableWidgetItem();
     Item1->setTextAlignment(Qt::AlignCenter);
     Item1->setFlags(Qt::ItemIsSelectable);
     Item1->QTableWidgetItem::setBackground(couleur_i);
     Tb_i->setItem(L,C,Item1);
}



void MainWindow::Tic2()
{

// à voir : ne lit pas les positions des doigts !!!

    //int i_max = liste_notes.count();
    int i_max=tableWidget_3->rowCount();
    QString s1, s2, s3;
    QString duree_txt;
    int di=0;

    int d_barre;
    float dt, vts;
    int itrv;

    vts = doubleSpinBox_vitesse->value();

    if ((num_ligne_en_cours >= 0) && (num_ligne_en_cours < i_max) )
    {
        s1 = tableWidget_3->item(num_ligne_en_cours, 6)->text();
        //s2 = s1.mid(1); // partie numérique de "*2"
        duree_txt = tableWidget_3->item(num_ligne_en_cours, 5)->text();
        d_barre = duree_txt.toInt();
        nb_colonnes_a_encadrer = d_barre;
        num_colonne_a_encadrer=Tp1;

        write_Time_line();
        encadrement_colonne();

       // memo_mesure_a_encadrer = mesure_a_encadrer;
        mesure_a_encadrer = s1.toInt(); // numero de la mesure

        tableWidget_3->selectRow(num_ligne_en_cours);

        //diF = duree_txt.toFloat();
        di = duree_txt.toInt();

        s1 = tableWidget_3->item(num_ligne_en_cours, 9)->text();
        s2 = tableWidget_3->item(num_ligne_en_cours, 10)->text();
        notes_silencieuses = true;
        joue_accord_complet(s1, s2);   // représentation graphique de la position avant de jouer la note
        notes_silencieuses = false;

        s1 = tableWidget_3->item(num_ligne_en_cours, 6)->text();
        if (s1 !=" ") {play_toc();}

        effacer_touches();

        joue_1_ligne(num_ligne_en_cours);

        s1 = tableWidget_3->item(num_ligne_en_cours, 11)->text();
        affi_positions_doigts_dans_status(s1);

        dt = 20.0 * (float)d_barre;
        dt *= (100.0 / vts);
        itrv = (int) dt;

        //dt = 40.0 * d_barre;
        //dt *= (10.0 - vts);
        //itrv = (int) dt;

        Timer2->setInterval(itrv);
    }
    num_ligne_en_cours++;
    if (num_ligne_en_cours >= i_max)
    {
        Bt_lecture_2->setText("joue > debut");
        Bt_lecture_2->setStyleSheet("QPushButton{background-color:#50FF1B;}");
        lecture_pause =0;
        QString s1;
        s1.setNum(num_ligne_en_cours);// conversion num -> txt
        Timer2->stop();
    }


    encadrement_ligne();
    Tp1 += di;

    nb_notes_jouees++;

    if (nb_notes_jouees>nb_notes_jouees_max)
    {
        nb_notes_jouees=0;
        lecture_pause =0;
        Timer2->stop();
    }
}


void MainWindow::play_toc()
{
  QString s1;
  s1="notes/bip.wav";
  if (n_player == 1)
  {
      player1->setSource(QUrl::fromLocalFile(s1));
      player1->play();
  }
  if (n_player == 2)
  {
      player2->setSource(QUrl::fromLocalFile(s1));
      player2->play();
  }
  if (n_player == 3)
  {
      player3->setSource(QUrl::fromLocalFile(s1));
      player3->play();
  }
  if (n_player == 4)
  {
      player4->setSource(QUrl::fromLocalFile(s1));
      player4->play();
  }

  if (n_player == 5)
  {
      player5->setSource(QUrl::fromLocalFile(s1));
      player5->play();
  }
  if (n_player == 6)
  {
      player6->setSource(QUrl::fromLocalFile(s1));
      player6->play();
  }
  if (n_player == 7)
  {
      player7->setSource(QUrl::fromLocalFile(s1));
      player7->play();
  }
  if (n_player == 8)
  {
      player8->setSource(QUrl::fromLocalFile(s1));
      player8->play();
  }

  n_player++;
  if (n_player >= 9) {n_player = 1;}

}


void MainWindow::play_note(int midi) // sortie audio
{
    if (notes_silencieuses == true) {return ;}

    if (!checkBox_not_erase->isChecked()) {on_Bt_RAZ_clicked();}

    QString s1, freq_txt;

    calcul_hauteur_note(midi);
    s1.setNum(midi);

    lineEdit_6->setText(s1);
    lineEdit_n_midi->setText(s1);

    float freq = freq_mid(midi-12);
    freq_txt.setNum(freq,'f', 2);
    lineEdit_freq->setText(freq_txt+" Hz");


    s1="notes/"+s1+".wav"; // fichiers audio comprenant une seule note chacun, voir dans le dossier "notes" sur le HDD

    if (n_player == 1)
    {
        player1->setSource(QUrl::fromLocalFile(s1));
        player1->play();
    }
    if (n_player == 2)
    {
        player2->setSource(QUrl::fromLocalFile(s1));
        player2->play();
    }
    if (n_player == 3)
    {
        player3->setSource(QUrl::fromLocalFile(s1));
        player3->play();
    }
    if (n_player == 4)
    {
        player4->setSource(QUrl::fromLocalFile(s1));
        player4->play();
    }

    if (n_player == 5)
    {
        player5->setSource(QUrl::fromLocalFile(s1));
        player5->play();
    }
    if (n_player == 6)
    {
        player6->setSource(QUrl::fromLocalFile(s1));
        player6->play();
    }
    if (n_player == 7)
    {
        player7->setSource(QUrl::fromLocalFile(s1));
        player7->play();
    }
    if (n_player == 8)
    {
        player8->setSource(QUrl::fromLocalFile(s1));
        player8->play();
    }

    n_player++;
    if (n_player >= 9) {n_player = 1;}
}


void MainWindow::on_Bt_E3_clicked()
{
    int n_midi=40;
    play_note(n_midi); // numérotation MIDI
    QColor c=liste_couleurs[4];
    dessine_1_note(6, 0, c); // sur le manche
    set_couleur_label(c, label5); // près de la touche piano
}

void MainWindow::on_Bt_F3_clicked()
{
    int n_midi=41;
    play_note(n_midi);
    QColor c=liste_couleurs[5];
    dessine_1_note(6, 1, c); // sur le manche
    set_couleur_label(c, label6); // près de la touche piano
}

void MainWindow::on_Bt_Fd3_clicked()
{
    int n_midi=42;
    play_note(n_midi);
    QColor c=liste_couleurs[6];
    dessine_1_note(6, 2, c); // sur le manche
    set_couleur_label(c, label7); // près de la touche piano
}

void MainWindow::on_Bt_G3_clicked()
{
    int n_midi=43;
    play_note(n_midi);
    QColor c=liste_couleurs[7];
    dessine_1_note(6, 3, c); // sur le manche
    set_couleur_label(c, label8); // près de la touche piano
}

void MainWindow::on_Bt_Gd3_clicked()
{
    int n_midi=44;
    play_note(n_midi);
    QColor c=liste_couleurs[8];
    dessine_1_note(6, 4, c); // sur le manche
    set_couleur_label(c, label9); // près de la touche piano
}

void MainWindow::on_Bt_A3_clicked()
{
    int n_midi=45;
    play_note(n_midi);
    QColor c=liste_couleurs[9];
    dessine_1_note(6, 5, c); dessine_1_note(5, 0, c); // sur le manche
    set_couleur_label(c, label10); // près de la touche piano
}

void MainWindow::on_Bt_Bb3_clicked()
{
    int n_midi=46;
    play_note(n_midi);
    QColor c=liste_couleurs[10];
    dessine_1_note(6, 6, c); dessine_1_note(5, 1, c);
    set_couleur_label(c, label11); // près de la touche piano
}

void MainWindow::on_BT_B3_clicked()
{
    int n_midi=47;
    play_note(n_midi);
    QColor c=liste_couleurs[11];
    dessine_1_note(6, 7, c); dessine_1_note(5, 2, c);
    set_couleur_label(c, label12); // près de la touche piano
}

void MainWindow::on_Bt_C4_clicked()
{
    int n_midi=48;
    play_note(n_midi);
    QColor c=liste_couleurs[0];
    dessine_1_note(6, 8, c); dessine_1_note(5, 3, c);
    set_couleur_label(c, label1_2);
}

void MainWindow::on_Bt_Cd4_clicked()
{
    int n_midi=49;
    play_note(n_midi);
    QColor c=liste_couleurs[1];
    dessine_1_note(6, 9, c); dessine_1_note(5, 4, c);
    set_couleur_label(c, label2_2);
}

void MainWindow::on_Bt_D4_clicked()
{
    int n_midi=50;
    play_note(n_midi);
    QColor c=liste_couleurs[2];
    dessine_1_note(6, 10, c); dessine_1_note(5, 5, c); dessine_1_note(4, 0, c);
    set_couleur_label(c, label3_2);
}

void MainWindow::on_Bt_Eb4_clicked()
{
    int n_midi=51;
    play_note(n_midi);
    QColor c=liste_couleurs[3];
    dessine_1_note(6, 11, c); dessine_1_note(5, 6, c); dessine_1_note(4, 1, c);
    set_couleur_label(c, label4_2);
}

void MainWindow::on_Bt_E4_clicked()
{
    int n_midi=52;
    play_note(n_midi);
    QColor c=liste_couleurs[4];
    dessine_1_note(6, 12, c); dessine_1_note(5, 7, c); dessine_1_note(4, 2, c);
    set_couleur_label(c, label5_2);
}

void MainWindow::on_Bt_F4_clicked()
{
    int n_midi=53;
    play_note(n_midi);
    QColor c=liste_couleurs[5];
    dessine_1_note(6, 13, c); dessine_1_note(5, 8, c); dessine_1_note(4, 3, c);
    set_couleur_label(c, label6_2);
}

void MainWindow::on_Bt_Fd4_clicked()
{
    int n_midi=54;
    play_note(n_midi);
    QColor c=liste_couleurs[6];
    dessine_1_note(6, 14, c); dessine_1_note(5, 9, c); dessine_1_note(4, 4, c);
    set_couleur_label(c, label7_2);
}

void MainWindow::on_Bt_G4_clicked()
{
    int n_midi=55;
    play_note(n_midi);
    QColor c=liste_couleurs[7];
    dessine_1_note(6, 15, c); dessine_1_note(5, 10, c); dessine_1_note(4, 5, c); dessine_1_note(3, 0, c);
    set_couleur_label(c, label8_2);
}

void MainWindow::on_Bt_Gd4_clicked()
{
    int n_midi=56;
    play_note(n_midi);
    QColor c=liste_couleurs[8];
    dessine_1_note(6, 16, c); dessine_1_note(5, 11, c); dessine_1_note(4, 6, c); dessine_1_note(3, 1, c);
    set_couleur_label(c, label9_2);
}

void MainWindow::on_Bt_A4_clicked()
{
    int n_midi=57;
    play_note(n_midi);
    QColor c=liste_couleurs[9];
    dessine_1_note(6, 17, c); dessine_1_note(5, 12, c); dessine_1_note(4, 7, c); dessine_1_note(3, 2, c);
    set_couleur_label(c, label10_2);
}

void MainWindow::on_Bt_Bb4_clicked()
{   int n_midi=58;
    play_note(n_midi);
    QColor c=liste_couleurs[10];
    dessine_1_note(6, 18, c); dessine_1_note(5, 13, c); dessine_1_note(4, 8, c); dessine_1_note(3, 3, c);
    set_couleur_label(c, label11_2);
}

void MainWindow::on_Bt_B4_clicked()
{
    int n_midi=59;
    play_note(n_midi);
    QColor c=liste_couleurs[11];
    dessine_1_note(2, 0, c);   dessine_1_note(3, 4, c); dessine_1_note(4, 9, c); dessine_1_note(5, 14, c);
    set_couleur_label(c, label12_2);
}

void MainWindow::on_Bt_C5_clicked()
{
    int n_midi=60;
    play_note(n_midi);
    QColor c=liste_couleurs[0];
    dessine_1_note(2, 1, c); dessine_1_note(3, 5, c); dessine_1_note(4, 10, c); dessine_1_note(5, 15, c);
    set_couleur_label(c, label1_3);
}

void MainWindow::on_Bt_Cd5_clicked()
{
    int n_midi=61;
    play_note(n_midi);
    QColor c=liste_couleurs[1];
    dessine_1_note(2, 2, c); dessine_1_note(3, 6, c); dessine_1_note(4, 11, c); dessine_1_note(5, 16, c);
    set_couleur_label(c, label2_3);
}

void MainWindow::on_Bt_D5_clicked()
{
    int n_midi=62;
    play_note(n_midi);
    QColor c=liste_couleurs[2];
    dessine_1_note(2, 3, c); dessine_1_note(3, 7, c); dessine_1_note(4, 12, c); dessine_1_note(5, 17, c);
    set_couleur_label(c, label3_3);
}

void MainWindow::on_Bt_Eb5_clicked()
{
    int n_midi=63;
    play_note(n_midi);
    QColor c=liste_couleurs[3];
    dessine_1_note(2, 4, c); dessine_1_note(3, 8, c); dessine_1_note(4, 13, c); dessine_1_note(5, 18, c);
    set_couleur_label(c, label4_3);
}

void MainWindow::on_Bt_E5_clicked()
{
    int n_midi=64;
    play_note(n_midi);
    QColor c=liste_couleurs[4];
    dessine_1_note(1, 0, c); dessine_1_note(2, 5, c); dessine_1_note(3, 9, c); dessine_1_note(4, 14, c);
    set_couleur_label(c, label5_3);

 }

void MainWindow::on_Bt_F5_clicked()
{
    int n_midi=65;
    play_note(n_midi);
    QColor c=liste_couleurs[5];
    dessine_1_note(1, 1, c); dessine_1_note(2, 6, c); dessine_1_note(3, 10, c); dessine_1_note(4, 15, c);
    set_couleur_label(c, label6_3);
}

void MainWindow::on_Bt_Fd5_clicked()
{
    int n_midi=66;
    play_note(n_midi);
    QColor c=liste_couleurs[6];
    dessine_1_note(1, 2, c); dessine_1_note(2, 7, c); dessine_1_note(3, 11, c); dessine_1_note(4, 16, c);
    set_couleur_label(c, label7_3);
}

void MainWindow::on_Bt_G5_clicked()
{
    int n_midi=67;
    play_note(n_midi);
    QColor c=liste_couleurs[7];
    dessine_1_note(1, 3, c); dessine_1_note(2, 8, c); dessine_1_note(3, 12, c); dessine_1_note(4, 17, c);
    set_couleur_label(c, label8_3);
}

void MainWindow::on_Bt_Gd5_clicked()
{
    int n_midi=68;
    play_note(n_midi);
    QColor c=liste_couleurs[8];
    dessine_1_note(1, 4, c); dessine_1_note(2, 9, c); dessine_1_note(3, 13, c); dessine_1_note(4, 18, c);
    set_couleur_label(c, label9_3);
}

void MainWindow::on_Bt_A5_clicked()
{
    int n_midi=69;
    play_note(n_midi);
    QColor c=liste_couleurs[9];
    dessine_1_note(1, 5, c); dessine_1_note(2, 10, c); dessine_1_note(3, 14, c);
    set_couleur_label(c, label10_3);
}

void MainWindow::on_Bt_Bb5_clicked()
{
    int n_midi=70;
    play_note(n_midi);
    QColor c=liste_couleurs[10];
    dessine_1_note(1, 6, c); dessine_1_note(2, 11, c); dessine_1_note(3, 15, c);
    set_couleur_label(c, label11_3);
}

void MainWindow::on_Bt_B5_clicked()
{
    int n_midi=71;
    play_note(n_midi);
    QColor c=liste_couleurs[11];
    dessine_1_note(1, 7, c); dessine_1_note(2, 12, c); dessine_1_note(3, 16, c);
    set_couleur_label(c, label12_3);
}


void MainWindow::on_Bt_C6_clicked()
{
    int n_midi=72;
    play_note(n_midi);
    QColor c=liste_couleurs[0];
    dessine_1_note(1, 8, c); dessine_1_note(2, 13, c); dessine_1_note(3, 17, c);
    set_couleur_label(c, label1_4);
}

void MainWindow::on_Bt_Cd6_clicked()
{
    int n_midi=73;
    play_note(n_midi);
    QColor c=liste_couleurs[1];
    dessine_1_note(1, 9, c); dessine_1_note(2, 14, c); dessine_1_note(3, 18, c);
    set_couleur_label(c, label2_4);
}


void MainWindow::on_Bt_D6_clicked()
{
    int n_midi=74;
    play_note(n_midi);
    QColor c=liste_couleurs[2];
    dessine_1_note(1, 10, c); dessine_1_note(2, 15, c);
    set_couleur_label(c, label3_4);
}

void MainWindow::on_Bt_Eb6_clicked()
{
    int n_midi=75;
    play_note(n_midi);
    QColor c=liste_couleurs[3];
    dessine_1_note(1, 11, c); dessine_1_note(2, 16, c);
    set_couleur_label(c, label4_4);
}

void MainWindow::on_Bt_E6_clicked()
{
    int n_midi=76;
    play_note(n_midi);
    QColor c=liste_couleurs[4];
    dessine_1_note(1, 12, c); dessine_1_note(2, 17, c);
    set_couleur_label(c, label5_4);
}

void MainWindow::on_Bt_F6_clicked()
{
    int n_midi=77;
    play_note(n_midi);
    QColor c=liste_couleurs[5];
    dessine_1_note(1, 13, c); dessine_1_note(2, 18, c);
    set_couleur_label(c, label6_4);
}

void MainWindow::on_Bt_Fd6_clicked()
{
    int n_midi=78;
    play_note(n_midi);
    QColor c=liste_couleurs[6];
    dessine_1_note(1, 14, c); dessine_1_note(2, 19, c);
    set_couleur_label(c, label7_4);
}

void MainWindow::on_Bt_G6_clicked()
{
    int n_midi=79;
    play_note(n_midi);
    QColor c=liste_couleurs[7];
    dessine_1_note(1, 15, c); dessine_1_note(2, 20, c);
    set_couleur_label(c, label8_4);
}

void MainWindow::on_Bt_Gd6_clicked()
{
    int n_midi=80;
    play_note(n_midi);
    QColor c=liste_couleurs[8];
    dessine_1_note(1, 16, c);
    set_couleur_label(c, label9_4);
}

void MainWindow::on_Bt_A6_clicked()
{
    int n_midi=81;
    play_note(n_midi);
    QColor c=liste_couleurs[9];
    dessine_1_note(1, 17, c);
    set_couleur_label(c, label10_4);
}

void MainWindow::on_Bt_Bb6_clicked()
{
    int n_midi=82;
    play_note(n_midi);
    QColor c=liste_couleurs[10];
    dessine_1_note(1, 18, c);
    set_couleur_label(c, label11_4);
}


void MainWindow::on_Bt_B6_clicked()
{
    int n_midi=83;
    play_note(n_midi);
    QColor c=liste_couleurs[11];
    dessine_1_note(1, 19, c);
    set_couleur_label(c, label12_4);
}

void MainWindow::on_Bt_C7_clicked()
{
    int n_midi=84;
    play_note(n_midi);
    QColor c=liste_couleurs[0];
    dessine_1_note(1, 20, c);
    //set_couleur_label(c, label13_4);
}



void MainWindow::joue_1_ligne(int ligne_i)
{
    QString s1;

    for(int C=0; C<4; C++)
    {
         //on_Bt_RAZ_clicked();
         s1 = tableWidget_3->item(ligne_i, C)->text();
         s1 = s1.left(3);
         int m1 = s1.toInt();
         execute_note_midi(m1);
    }
}


void MainWindow::complete_case(int row, int column, QString s1, QColor c1, QColor c2, bool bold1, QTableWidget *QTI)
{
    QTableWidgetItem *Item1 = new QTableWidgetItem();
    Item1->QTableWidgetItem::setForeground(c1);
    Item1->QTableWidgetItem::setBackground(c2);

    QFont font1;
    font1.setBold(bold1);
    Item1->setFont(font1);
    Item1->setTextAlignment(Qt::AlignCenter);

    Item1->setText(s1);
    QTI->setItem(row,column,Item1);
}


void MainWindow::affi_positions_doigts_dans_status(QString s_i)
{
// et dans le cadre 'Position de doigts' (tableWidget_doigts)
// et numérote les notes jouées sur le manche

    QString s2, s3;
    int corde1, case1, num1;
    init_tableWidget_doigts();

    s3="";
    //---------------------------------------------------------------------------------------
    s2=extraction_data(s_i, "D0v=");
    if((s2 != "") && (s2 != "-"))
    {
        num1=0;
        tableWidget_doigts->setItem(0, 0, new QTableWidgetItem (s2) ); // corde
        tableWidget_doigts->item(0, 0)->setTextAlignment(Qt::AlignCenter);
        s3 += "( DOIGT 1 corde " + s2;
        corde1 = s2.toInt();
        label_44->setText("corde " + s2);

        s2=extraction_data(s_i, "D0h=");
        case1 = s2.toInt();
        s3 += " case " + s2 + " ) ";
        tableWidget_doigts->setItem(0, 1, new QTableWidgetItem (s2) ); // case
        tableWidget_doigts->item(0, 1)->setTextAlignment(Qt::AlignCenter);
        numerote_1_note(corde1, case1, num1);
        label_45->setText("case " + s2);
    }
//---------------------------------------------------------------------------------------
    s2=extraction_data(s_i, "D1v=");
    if((s2 != "") && (s2 != "-"))
    {
        num1=1;
        tableWidget_doigts->setItem(1, 0, new QTableWidgetItem (s2) ); // corde
        tableWidget_doigts->item(1, 0)->setTextAlignment(Qt::AlignCenter);
        s3 += "( DOIGT 1 corde " + s2;
        corde1 = s2.toInt();
        label_44->setText("corde " + s2);

        s2=extraction_data(s_i, "D1h=");
        case1 = s2.toInt();
        s3 += " case " + s2 + " ) ";
        tableWidget_doigts->setItem(1, 1, new QTableWidgetItem (s2) ); // case
        tableWidget_doigts->item(1, 1)->setTextAlignment(Qt::AlignCenter);
        numerote_1_note(corde1, case1, num1);
        label_45->setText("case " + s2);
    }
//---------------------------------------------------------------------------------------
    s2=extraction_data(s_i, "D2v=");
    if((s2 != "") && (s2 != "-"))
    {
        bool ok; int dec = s2.toInt(&ok, 10);
        if (ok==true)
        {
            num1=2;
            tableWidget_doigts->setItem(2, 0, new QTableWidgetItem (s2) ); // corde
            tableWidget_doigts->item(2, 0)->setTextAlignment(Qt::AlignCenter);
            s3 += "( DOIGT 2 corde " + s2;
            corde1 = s2.toInt();
            label_44->setText("corde " + s2);


            s2=extraction_data(s_i, "D2h=");
            case1 = s2.toInt();
            label_45->setText("case " + s2);

            s3 += " case " + s2 + " ) ";
            tableWidget_doigts->setItem(2, 1, new QTableWidgetItem (s2) ); // case
            tableWidget_doigts->item(2, 1)->setTextAlignment(Qt::AlignCenter);
            numerote_1_note(corde1, case1, num1);
        }
    }
//---------------------------------------------------------------------------------------

    s2=extraction_data(s_i, "D3v=");
    if((s2 != "") && (s2 != "-"))
    {
       bool ok; int dec = s2.toInt(&ok, 10);
       if (ok==true)
       {
            num1=3;
            tableWidget_doigts->setItem(3, 0, new QTableWidgetItem (s2) ); // corde
            tableWidget_doigts->item(3, 0)->setTextAlignment(Qt::AlignCenter);
            s3 += "( DOIGT 3 corde " + s2;
            corde1 = s2.toInt();
            label_44->setText("corde " + s2);


            s2=extraction_data(s_i, "D3h=");
            case1 = s2.toInt();
            s3 += " case " + s2 + " ) ";
            label_45->setText("case " + s2);
            tableWidget_doigts->setItem(3, 1, new QTableWidgetItem (s2) ); // case
            tableWidget_doigts->item(3, 1)->setTextAlignment(Qt::AlignCenter);
            numerote_1_note(corde1, case1, num1);
        }
    }
//---------------------------------------------------------------------------------------
    s2=extraction_data(s_i, "D4v=");
    if((s2 != "") && (s2 != "-"))
    {
        bool ok; int dec = s2.toInt(&ok, 10);
        if (ok==true)
        {
            num1=4;
            tableWidget_doigts->setItem(4, 0, new QTableWidgetItem (s2) ); // corde
            tableWidget_doigts->item(4, 0)->setTextAlignment(Qt::AlignCenter);
            s3 += "( DOIGT 4 corde " + s2;
            corde1 = s2.toInt();
            label_44->setText("corde " + s2);


            s2=extraction_data(s_i, "D4h=");
            case1 = s2.toInt();
            s3 += " case " + s2 + " ) ";
            label_45->setText("case " + s2);
            tableWidget_doigts->setItem(4, 1, new QTableWidgetItem (s2) ); // case
            tableWidget_doigts->item(4, 1)->setTextAlignment(Qt::AlignCenter);
            numerote_1_note(corde1, case1, num1);
        }
    }
//---------------------------------------------------------------------------------------

    statusbar->showMessage(s3);
}

/*
QString MainWindow::nom_note(int mid)
{
    QString s1;

    int h1 = calcul_hauteur_note(mid);
    h1-=3;
    if(h1<0){h1+=12;}
    if(h1>11){h1-=12;}
    s1 = gamme_chromatique[h1];
    return s1;
}
*/

void MainWindow::affiche_liste_notes() // en TEXTE dans le petit tableau
{
    NOTE_importee note_i;
    QString s1;

    // gestion_mesures();

    tableWidget_lst_notes->clear();
    tableWidget_lst_notes->setRowCount(0);
    init_TAB_lst_notes();

    int n_max = liste_NOTES_importees.length();
    for(int n=0; n<n_max; n++)
    {
        note_i=liste_NOTES_importees[n];
        int numero = note_i.numero;
        int midi = note_i.midi;
        int n_barre =note_i.n_barre;
        int n_temps =note_i.n_temps;
        int duree = note_i.duree;

        int num_ligne = tableWidget_lst_notes->rowCount();
        tableWidget_lst_notes->setRowCount(num_ligne+1); // ajout une ligne au tableau

        s1.setNum(numero);
        complete_case(n, 0, s1, "#000000", "#FFFFFF", false, tableWidget_lst_notes);

        s1.setNum(midi);
        int h1 = calcul_hauteur_note(midi); h1-=3; if(h1<0){h1+=12;} if(h1>11){h1-=12;}
        QColor couleur1 = liste_couleurs[h1];
        complete_case(n, 1, s1, "#000000", couleur1, true, tableWidget_lst_notes);


        s1 = nom_note_FR(midi);
        complete_case(n, 2, s1, "#000000", "#FFFFFF", false, tableWidget_lst_notes);

        s1.setNum(n_barre);
        complete_case(n, 3, s1, "#000000", "#FFFFFF", false, tableWidget_lst_notes);

        s1.setNum(n_temps); // ok
        complete_case(n, 4, s1, "#000000", "#FFFFFF", true, tableWidget_lst_notes);

        s1.setNum(duree); //ok
        complete_case(n, 5, s1, "#000000", "#FFFFFF", true, tableWidget_lst_notes);

 /*
        if (duree == 16) {s1 = "R";} // Ronde
        if (duree == 12) {s1 = "B.";}
        if (duree == 8) {s1 = "B";} // blanche
        if (duree == 4) {s1 = "N";} // noire
        if (duree == 2) {s1 = "c";} // croche
        if (duree == 1) {s1 = "db_c";} // double croche
        if (duree == 0) {s1 = "-";}
        //if (midi == 100) {s1 = "--";}

        complete_case(n, 6, s1, "#000000", "#FFFFFF", true, tableWidget_lst_notes);
*/
    }
}

/*
void MainWindow::affiche_liste_notes() // en TEXTE dans le petit tableau
{
    NOTE_importee note_i;
    QString s1;

    tableWidget_lst_notes->clear();
    tableWidget_lst_notes->setRowCount(0);
    init_TAB_lst_notes();

    int n_max = liste_NOTES_importees.length();
    for(int n=0; n<n_max; n++)
    {
        note_i=liste_NOTES_importees[n];
        int numero = note_i.numero;
        int midi = note_i.midi;
        int n_barre =note_i.n_barre;
        int n_temps =note_i.n_temps;
        int duree = note_i.duree;


        int num_ligne = tableWidget_lst_notes->rowCount();
        tableWidget_lst_notes->setRowCount(num_ligne+1); // ajout une ligne au tableau

        s1.setNum(numero);
        complete_case(n, 0, s1, "#000000", "#FFFFFF", false, tableWidget_lst_notes);

        s1.setNum(midi);
        int h1 = calcul_hauteur_note(midi); h1-=3; if(h1<0){h1+=12;} if(h1>11){h1-=12;}
        QColor couleur1 = liste_couleurs[h1];
        complete_case(n, 1, s1, "#000000", couleur1, true, tableWidget_lst_notes);

        s1 = nom_note(midi);
        complete_case(n, 2, s1, "#000000", "#FFFFFF", false, tableWidget_lst_notes);

        s1.setNum(n_barre);
        complete_case(n, 3, s1, "#000000", "#FFFFFF", false, tableWidget_lst_notes);

        s1.setNum(n_temps);
        complete_case(n, 4, s1, "#000000", "#FFFFFF", true, tableWidget_lst_notes);

        s1.setNum(duree);
        complete_case(n, 5, s1, "#000000", "#FFFFFF", true, tableWidget_lst_notes);

        if (duree == 16) {s1 = "R";} // Ronde
        if (duree == 12) {s1 = "B.";}
        if (duree == 8) {s1 = "B";} // blanche
        if (duree == 4) {s1 = "N";} // noire
        if (duree == 2) {s1 = "c";} // croche
        if (duree == 1) {s1 = "db_c";} // double croche
        if (duree == 0) {s1 = "-";}

        complete_case(n, 5, s1, "#000000", "#FFFFFF", true, tableWidget_lst_notes);
    }
}
*/


void MainWindow::on_tableWidget_3_cellClicked(int row, int column)
{
    ligne_TW3 = row;
    QString s1, s2, s3, ACC, cases;
    QString duree_txt;
    int di=0;
    int R;

    //checkBox_not_erase->setChecked(true);

    R = tableWidget_3->currentRow();
    num_ligne_en_cours = row;
    s1.setNum(R+1);
    lineEdit_9->setText(s1);

    encadrement_ligne();

    s2 = tableWidget_3->item(row, column)->text(); // actuellement dans la case cible
    s1 = lineEdit_n_midi->text();

    int m1 = s1.toInt();
    if ((column<3) && mode_depot_note == true)
    {
        mode_depot_note = false;
        statusbar->showMessage("");
        MainWindow::setCursor(Qt::ArrowCursor);
        if(s1 != s2) // alors on inscrit la nouvelle valeur dans la case
        {
            int h1 = calcul_hauteur_note(m1); // h1 = 0..11
            h1-=3;
            if(h1<0){h1+=12;}
            if(h1>11){h1-=12;}

            s3 = " " + gamme_chromatique[h1];
            s1 += s3;

            QColor couleur_case = liste_couleurs[h1];

            complete_case(row, column, s1, "#000000", couleur_case, false,  tableWidget_3);

            tableWidget_3->resizeColumnsToContents();
        }
        else // on efface la valeur
        {
            tableWidget_3->setItem(row, column, new QTableWidgetItem ("--") );
        }
        init_TW_T();
    }


    if (column==4) // celle qui contient les petits boutons ( triangles '>' verts)
    {
        //effacer_calque(scene1, calque_notes);

        ACC = tableWidget_3->item(row, 9)->text();
        cases = tableWidget_3->item(row, 10)->text();
 //qDebug() << "ACC" << ACC;
 //qDebug() << "cases" << cases;

        notes_silencieuses = true;
        joue_accord_complet(ACC, cases);  // représentation graphique de la position avant de jouer la note
        notes_silencieuses = false;

        joue_1_ligne(row);

        s1 = tableWidget_3->item(row, 11)->text();
        affi_positions_doigts_dans_status(s1);
    }


    if (column==5) { write_Time_line(); }

    if (column==8) // ACC
    {
        s1 = tableWidget_3->item(row, 9)->text();
        s2 = tableWidget_3->item(row, 10)->text();


        if (s1 !=" ")
        {
            notes_silencieuses = true;
            joue_accord_complet(s1, s2);
            notes_silencieuses = false;
        }
    }

    if (column==11)
    {
        QMessageBox msgBox;
        QString s1;
        s1 =  "Colonne read only";
        s1 += "\n";
        s1 += "Utiliser le cadre 'de saisie 'Position des doigts'";
        s1 += "\n";
        s1 += "pour saisir les positions.";
        msgBox.setText(s1);
        msgBox.exec();
    }

    s2 = tableWidget_3->item(row, 6)->text();
    s2 = s2.mid(1);
    mesure_a_encadrer = s2.toInt();

    write_Time_line();

    duree_txt = tableWidget_3->item(R, 5)->text();

    di = duree_txt.toInt();
    nb_colonnes_a_encadrer = di;

    int T_note;
    T_note = calcul_T_note(row);
    num_colonne_a_encadrer = T_note;

    encadrement_colonne();
}


/*
void MainWindow::on_tableWidget_3_currentCellChanged(int currentRow, int currentColumn, int previousRow, int previousColumn)
{
    if (currentColumn == 5) {gestion_mesures();} // si on change la durée d'une note
}
*/



void MainWindow::on_Bt_ACCORD_1_clicked()
{
 // accord majeur
    //effacer_calque(scene1, calque_notes);
    on_Bt_RAZ_clicked();
    label_44->setText("-");
    label_45->setText("-");

    checkBox_not_erase->setChecked(true);

    QString s1, s2, s3, s4;
    int d = spinBox_2->value();

    s1 = gamme_chromatique[d];
    s2="M";
    s1+=s2;
    lineEdit_10->setText(s1);

    case_min = spinBox_4->value(); s3.setNum(case_min);
    case_max = spinBox_5->value(); s4.setNum(case_max);
    lineEdit_14->setText(s3 + "a" +s4);

    label_43->clear();
    encadre_accord(case_min, case_max);

    //on_Bt_RAZ_clicked();
    execute_note_midi(28 + spinBox_2->value());
    execute_note_midi(31 + spinBox_2->value());
    execute_note_midi(36 + spinBox_2->value());

    execute_note_midi(28+12 + spinBox_2->value());
    execute_note_midi(31+12 + spinBox_2->value());
    execute_note_midi(36+12 + spinBox_2->value());

    execute_note_midi(28+12+12 + spinBox_2->value());
    execute_note_midi(31+12+12 + spinBox_2->value());
    execute_note_midi(36+12+12 + spinBox_2->value());

    execute_note_midi(28+12+12+12 + spinBox_2->value());
    execute_note_midi(31+12+12+12 + spinBox_2->value());
    execute_note_midi(36+12+12+12 + spinBox_2->value());

    type_accords = 1;
}



void MainWindow::on_Bt_ACCORD_2_clicked()
{
// accord mineur

    effacer_calque(scene1, calque_notes);
    label_44->setText("-");
    label_45->setText("-");

    checkBox_not_erase->setChecked(true);

    QString s1, s2, s3, s4;
    int d = spinBox_2->value();

    s1 = gamme_chromatique[d];
    s2="m";
    s1+=s2;
    lineEdit_10->setText(s1);

    case_min = spinBox_4->value();  s3.setNum(case_min);
    case_max = spinBox_5->value();  s4.setNum(case_max);
    lineEdit_14->setText(s3 + "a" +s4);


    label_43->clear();
    encadre_accord(case_min, case_max);

    //on_Bt_RAZ_clicked();


    execute_note_midi( 31 + spinBox_2->value());
    execute_note_midi( 36 + spinBox_2->value());
    execute_note_midi( 39 + spinBox_2->value());

    execute_note_midi( 31+12 + spinBox_2->value());
    execute_note_midi( 36+12 + spinBox_2->value());
    execute_note_midi( 39+12 + spinBox_2->value());

    execute_note_midi( 31+12+12 + spinBox_2->value());
    execute_note_midi( 36+12+12 + spinBox_2->value());
    execute_note_midi( 39+12+12 + spinBox_2->value());

    execute_note_midi( 31+12+12+12 + spinBox_2->value());
    execute_note_midi( 36+12+12+12 + spinBox_2->value());
    execute_note_midi( 39+12+12+12 + spinBox_2->value());

    type_accords = 2;
}


void MainWindow::on_Bt_ACCORD_3_clicked()
{
// accord 7eme de dominante

    effacer_calque(scene1, calque_notes);
    label_44->setText("-");
    label_45->setText("-");
    checkBox_not_erase->setChecked(true);

    QString s1, s2, s3, s4;
    int d = spinBox_2->value();

    s1 = gamme_chromatique[d];
    s2="7";
    s1+=s2;
    lineEdit_10->setText(s1);

    case_min = spinBox_4->value();  s3.setNum(case_min);
    case_max = spinBox_5->value();  s4.setNum(case_max);
    lineEdit_14->setText(s3 + "a" +s4);

    label_43->clear();
    encadre_accord(case_min, case_max);

    //on_Bt_RAZ_clicked();
    execute_note_midi( 36 + spinBox_2->value());
    execute_note_midi( 40 + spinBox_2->value());
    execute_note_midi( 43 + spinBox_2->value());
    execute_note_midi( 58 + spinBox_2->value());

    execute_note_midi( 36+12 + spinBox_2->value());
    execute_note_midi( 40+12 + spinBox_2->value());
    execute_note_midi( 43+12 + spinBox_2->value());
    execute_note_midi( 58+12 + spinBox_2->value());

    execute_note_midi( 36+12+12 + spinBox_2->value());
    execute_note_midi( 40+12+12 + spinBox_2->value());
    execute_note_midi( 43+12+12 + spinBox_2->value());
    execute_note_midi( 58+12+12 + spinBox_2->value());

    type_accords = 3;
}


void MainWindow::on_Bt_NO_ACCORD_clicked() // note seule
{
    QString  s3, s4;

    effacer_calque(scene1, calque_notes);

    lineEdit_10->clear();
    lineEdit_10->setText("-");
    label_43->clear();

    case_min = spinBox_4->value();
    s3.setNum(case_min);

    case_max = case_min;

    spinBox_5->setValue(case_max);
    s4.setNum(case_max);

    lineEdit_14->setText(s3 + "a" +s4);

    type_accords = 0;
}



void MainWindow::joue_accord_complet(QString ACC, QString cases)
{
// exemple: (Sol, 3a5) -> c.a.d case 3 à case 5
    QString s1, s2b, s2c, s3, s4;
    //QString degré_txt;
    QString type;
    int p1, p2;
    s1 = ACC;  // exemples : Sim, Sibm, Do, Dom, La, Lam,  Sol, Solm, Mi7

    if (!checkBox_not_erase->isChecked()) {on_Bt_RAZ_clicked();}

    if ((ACC == "") || (ACC == " ") ) { return; }

/*
s1 "La"
s1 "Fa#"
s1 "Mi7"
s1 "Sim"
s1 "Sibm"
s1 "Do"
*/
// détection du degré (0 pour Do ,  à 11 pour Si)
// rappel : gamme_chromatique<<"Do"<<"Do#"<<"Ré"<<"Mib"<<"Mi"<<"Fa"<<"Fa#"<<"Sol"<<"Sol#"<<"La"<<"Sib"<<"Si";

    int n=11;
    int deg = -1;
    bool ok = false;
    while ((n>0) && (ok == false))
    {
        QString s2a = gamme_chromatique[n];
        p1 =  s1.indexOf(s2a);
        if (p1 != -1) {ok = true;}
        n--;
    }
    if (ok == true) {deg = n+1; }

    p1 =  s1.indexOf("b");
    if (p1 != -1) {deg --;}  // bémol

    s2b = ACC.right(1); // m, 7, mais aussi # ou la dernière lettre du nom de la note !

    type = "MAJ"; // à priori
    if (s2b == "m") {type = "min";}
    if (s2b == "7") {type = "dom";}
    if (s2b == "-") {type = "-";} // note seule

// intervalle de cases à jouer :

    s2c = cases; // "0a3"  ou "12a14" ...
    p2=s2c.indexOf("a");

    if (p2 != -1)
    {
        s3=s2c.left(p2);
        case_min = s3.toInt();
        spinBox_4->setValue(case_min);

        s4 = s2c.mid(p2+1, 255);
        int v4 = s4.toInt();

        if (v4 >= case_min) // on accepte une case unique (genre "7a7") pour forcer une note unique à sa place
        {
            case_max = v4; // ici on enregistre le numero de la case max
            spinBox_5->setValue(case_max);
        }
    }

    else
    {
        case_min = 0;
        spinBox_4->setValue(case_min);
        case_max = 20;  // numéro de la case
        spinBox_5->setValue(case_max); // nombre de cases
    }

    notes_pleines = false; // ne représentera qu'un cercle

    if (type=="MAJ") // accord majeur
    {
        spinBox_2->setValue(deg); // spinBox dans le cadre 'Configurateur d'Accords'
        on_Bt_ACCORD_1_clicked();
    }



    if (type=="min") // accord mineur
    {
        spinBox_2->setValue(deg);
        on_Bt_ACCORD_2_clicked();
    }


    if (type=="dom") // 7eme de dominante
    {
        spinBox_2->setValue(deg);
        on_Bt_ACCORD_3_clicked();
    }


    if (type=="-") // note seule
    {
       // spinBox_2->setValue(D);
       // on_Bt_ACCORD_3_clicked();

        on_Bt_RAZ_clicked();
    }

/*
    case_min = 0;
    spinBox_4->setValue(case_min);
    case_max = 20;
    spinBox_5->setValue(case_max);
*/
    notes_pleines = true;

    s1 = type;
    if (s1 == "dom") {s1 = "7e dom";}
    label_43->setText(lineEdit_8->text() + " " +s1);


}


void MainWindow::affiche_details_note(uint midi)
{
    QString s1;
    s1.setNum(midi);
    s1 = "m" + s1;
    lineEdit_7->setText(s1);

    affi_txt_en_couleur(midi, lineEdit_7b);
    lineEdit_7b->setText(nom_note_FR(midi));

    affi_txt_en_couleur(midi, lineEdit_7e);

    s1=nom_note_GB(midi);
    s1+=nom_octave_GB(midi);
    lineEdit_7e->setText(s1);
}


void MainWindow::mousePressEvent(QMouseEvent *event)
{
    QString s1, s2, s3;
    int x_min, x_max, y_min, y_max;

    x_min = graphicsView1->x();
    x_max = x_min + graphicsView1->width();
    y_min = graphicsView1->y();
    y_max = y_min + graphicsView1->height();

    x_clic_ecran = event->position().x();
    y_clic_ecran = event->position().y();

    if (x_clic_ecran > x_min && x_clic_ecran < x_max && y_clic_ecran > y_min && y_clic_ecran < y_max)
    {

// suite à un clic sur le manche :
        detecte_note_xy(x_clic_ecran, y_clic_ecran, &corde_jouee, &case_jouee); // actualise les variables globales

        s1.setNum(case_jouee);    lineEdit_case_i->setText(s1);
        s1.setNum(corde_jouee);   lineEdit_corde_i->setText(s1);

        if (corde_jouee>0)
        {
            case_min = 0;
            case_max = 20;
           // checkBox_not_erase->setChecked(false);

            if (!checkBox_not_erase->isChecked()) {on_Bt_RAZ_clicked();}

            s2.setNum(corde_jouee);
            label_44->setText("corde " + s2);
            s3.setNum(case_jouee);
            label_45->setText("case " + s3);

            n_midi_jouee = calcul_midi(corde_jouee, case_jouee);

            //affiche_details_note(n_midi_jouee);

            calcul_hauteur_note(n_midi_jouee);
            execute_note_midi( n_midi_jouee);
        }
    }
    else
    {
        mode_depot_note = false;
        statusbar->showMessage("");
        MainWindow::setCursor(Qt::ArrowCursor);
    }
}


void MainWindow::on_spinBox_2_valueChanged(int arg1)
{
    int n=arg1;
    lineEdit_8->setText(gamme_chromatique[n]);

    lineEdit_10->clear();
    lineEdit_14->clear();

}



void MainWindow::save_fichier_lst()
{
// enregisterment incrémentiel sur HDD (nom de fichier = 1..2...3...)

    QString s1;
    //QString ligne_i;
    int numero=0;
    QString s2;
    QString chemin_out;

    lecture_pause = 1;
    Bt_lecture_2->setText(">");
    Bt_lecture_2->setStyleSheet("QPushButton{background-color:#50FF1B;}");
    lecture_pause =0;
    s1.setNum(num_ligne_en_cours);// conversion num -> txt
    Timer2->stop();

    chemin_out = string_currentDir; //QDir::homePath() + "/GUITARE/ACCORDS/";


/*
    if (!dossier_out.exists())
    {
        QMessageBox msgBox;
        msgBox.setText("Le dossier : " + dossier_out.dirName() + "  n'éxiste pas, je le crée");
        msgBox.exec();
    }
*/
    bool existe =1;
    while(existe)
    {
        numero++;
        s2.setNum(numero);
        existe  = QFile::exists(chemin_out + s2 + ".lst");


/*
        QMessageBox msgBox;
        QString s1;
        s1 = "Le fichier de destination (" + chemin_out + s2 + ".lst ) existe déjà";
        msgBox.setText(s1);
        msgBox.exec();
*/
    }

    s2.setNum(numero);
    int nb_lignes;

    QFile file1(chemin_out + s2 + ".lst");
    //file1.remove();

    if (file1.open(QIODevice::WriteOnly | QIODevice::Text))
    {
        QTextStream file_out(&file1);

        int vitesse = doubleSpinBox_vitesse->value();
        QString s1;
        s1.setNum(vitesse);
        file_out << "v=" + s1 + ";";
        file_out << char(10);
        nb_lignes = liste_accords.length();
        for (int i=0; i<nb_lignes; i++)
        {
            file_out << liste_accords[i]; // << char(10);
        }
    }
    file1.close();

    QMessageBox msgBox;
    s1="Fichier enregistré: " + chemin_out + s2 + ".lst";
    msgBox.setText(s1);
    msgBox.exec();
}


int MainWindow::constitue_liste_accords() // en vue de l'enregistrement sur le HDD (par la fonction 'save_fichier_lst()' ci-dessus)
{
// remarque: les codes midi sont 40..84 qui correspondent à des caractères ASCII classiques.
// la valeur 100 est utilisée (ici) pour coder les barres de mesure
// plus exactement, les codes ascii 32..126 codents poue des caratères classiques.
// on peut donc les encoder dans des QString qui eux sont facilement recordables...
    QString s1, s2, s3, s4; // les 4 valeurs midi d'un accord sous forme de texte
    QString ligne_i;
    int m1, p1;

    liste_accords.clear();
    int RC=tableWidget_3->rowCount();

    int L_save_min = lineEdit_12->text().toInt() -1;
    int L_save_max = lineEdit_13->text().toInt();

    if (L_save_min < 0)  {L_save_min = 0;}
    if (L_save_max > RC) {L_save_max = RC;}

    if ((L_save_max-L_save_min) < 2)
    {
        QMessageBox msgBox;
        msgBox.setText("Le tableau doit contenir au minimum 2 lignes !");
        msgBox.exec();
        return 1;
    }

    for(int L=L_save_min; L<L_save_max; L++)
    {
        ligne_i.clear();
        s1 = tableWidget_3->item(L, 0)->text();  s1 = s1.left(2);
        m1 = s1.toInt();  if ((m1<40)||(m1>84)) {s1="";} // code midi de la note

        s1 = "m1=" +s1 + ";";
        ligne_i += s1;

        s1 = tableWidget_3->item(L, 1)->text();  s1 = s1.left(2);
        m1 = s1.toInt();  if ((m1<40)||(m1>84)) {s1="";}
        s1 = "m2=" +s1 + ";";
        ligne_i += s1;

        s1 = tableWidget_3->item(L, 2)->text();  s1 = s1.left(2);
        m1 = s1.toInt();  if ((m1<40)||(m1>84)) {s1="";}
        s1 = "m3=" +s1 + ";";
        ligne_i += s1;

        s1 = tableWidget_3->item(L, 3)->text(); // commentaire
        s1 = "cmt=" +s1 + ";";
        ligne_i += s1;

        s1 = tableWidget_3->item(L, 5)->text(); // DUREE
        s1 = " " + s1;  s1=s1.right(2); // ajoute 1 espace si nombre<10

        s1 = "d=" +s1 + ";"; // durée
        ligne_i += s1;

        s1 = tableWidget_3->item(L, 6)->text(); // MESURE
        s1 = "M=" +s1 + ";";
        ligne_i += s1;

        s1 = tableWidget_3->item(L, 7)->text(); // tps
        s1 = "T=" +s1 + ";";
        ligne_i += s1;

        //s1 = tableWidget_3->item(L, 8)->text(); // disponible
        //s1 = "x=" +s1 + ";";
        //ligne_x += s1;

        s1 = tableWidget_3->item(L, 9)->text(); // ACC  // "11min
        s1 = "a=" + s1 + ";";
        ligne_i += s1;

        s1 = tableWidget_3->item(L, 10)->text(); ; // "7a9"
        s1 = "cases=" + s1 + ";";
        ligne_i += s1;

        s1 = tableWidget_3->item(L, 11)->text(); // doigts (la case contient toute le string en question),
// voir la fonction : 'on_Bt_copie_doigts_to_TW3_clicked()' qui constitue ce string à partir du 'tableWidget_doigts.'

qDebug() << "" << s1;
qDebug() << "______________";

        ligne_i += s1;

        ligne_i += '\n';

        liste_accords << ligne_i;
    }
    return 0;
}



void MainWindow::on_Bt_save_clicked()
{
    int R = constitue_liste_accords();
    if (R == 0) { save_fichier_lst(); }

}


int MainWindow::dechiffre_note(QString label_i, int L, int c)
{

    int p1a, p1b, m1, h1;
    QString ligne_i=liste_accords[L];
    QString s1, s2;
    QColor couleur1;

    p1a=ligne_i.indexOf(label_i);
    p1b=ligne_i.indexOf(";",p1a);
    s1 = ligne_i.mid(p1a+3, p1b-(p1a+3));

    if (s1=="")    { return 0; }

    m1 = s1.toInt();

    if (m1==0) {return 0;}

    h1 = calcul_hauteur_note(m1); // h1 = 0..11
    h1-=3;
    while(h1<0){h1+=12;}
    if(h1>11){h1-=12;}
    couleur1 = liste_couleurs[h1];
    s2 = " " + gamme_chromatique[h1];

    s1 += s2;

    complete_case(L, c, s1, "#000000", couleur1, false, tableWidget_3);
    return p1a;
}



int MainWindow::open_fichier_lst() // cette fonction est appelée par la fonction 'write_Tableau_vertical()'
{
    QString ligne_i, str1;
    QString s1;
    int p1a, p1b;

// stop execution en cours
    lecture_pause = 1;
    Bt_lecture_2->setText("joue > debut");
    Bt_lecture_2->setStyleSheet("QPushButton{background-color:#50FF1B;}");
    lecture_pause =0;

    s1.setNum(num_ligne_en_cours);// conversion num -> txt
    Timer2->stop();

    string_currentFile = QFileDialog::getOpenFileName(this, tr("Ouvrir Fichier accords..."), string_currentDir,
                                                  tr("Fichiers lst (*.lst);;All Files (*)"));

//    qDebug() << "string_currentFile" << string_currentFile;

    if (string_currentFile != "")
    {
        save_fichier_ini();
        liste_str_in.clear();
        liste_accords.clear();
    }
    else {return 0;}

    int p1 = string_currentFile.lastIndexOf("/");

    string_currentDir =string_currentFile.left(p1+1);

    if (!string_currentFile.isEmpty())
    {
        lineEdit_1->setText(string_currentFile);
    }
    else {return 0;}

    QFile file1(string_currentFile);
    if (!file1.open(QIODevice::ReadOnly | QIODevice::Text)) return 1;
    QTextStream TextStream1(&file1);

    int num_ligne = 0;
    ligne_i = TextStream1.readLine(); // vitesse

    p1a=ligne_i.indexOf("v="); // duree
    p1b=ligne_i.indexOf(";",p1a);
    s1 = ligne_i.mid(p1a+2, p1b-(p1a+2));

    int v1;
    v1 = s1.toFloat();
    doubleSpinBox_vitesse->setValue(v1);

    while ( !TextStream1.atEnd() )
    {
        ligne_i = TextStream1.readLine();
        liste_accords += ligne_i;
        num_ligne++;
    }

    file1.close();

    str1.setNum(num_ligne);
    lineEdit_2->setText(str1 + " lignes");

    int nb_de_lignes = num_ligne;

    L_save_max = nb_de_lignes;

    s1.setNum(0);
    lineEdit_12->setText(s1);

    s1.setNum(nb_de_lignes);
    lineEdit_13->setText(s1);

    return nb_de_lignes;
}


//---------------------------------------------------------------------------------------


void MainWindow::write_Time_line()
{

    int m1;
    int R;
    QColor couleur1;
    int duree_note, intervalle_t, Ti1, Ti2, numero_mesure;
    QString s1, s2, s3, sm;
    intervalle_t=0;
    Ti1=0;

    int Rmax= tableWidget_3->rowCount();
    if (Rmax > 100) {Rmax =100;} // évite de saturer la mémoire RAM de l'ordi sur de morceaux trops longs!!

// ------------- colorie les cases horizontales (notes) ---------------------------
    Ti2=0;

    R=0;
    while ((R < Rmax) && Ti2 < 300)
    {
        s1 = tableWidget_3->item(R, 5)->text();
        duree_note = s1.toInt();

        for (int dt=0; dt<duree_note; dt++)
        {
            s1 = tableWidget_3->item(R, 0)->text();
            s1 = s1.left(2);
            m1 = s1.toInt();
            if ((m1 > 51) && (m1 < 97)) // si présence d'un code midi
            {
                couleur1 = tableWidget_3->item(R, 0)->background().color();
                if(couleur1 != "#000000") { complete_case(1, Ti2, " ", "#CECECE", couleur1, false, tableWidget_T);}
            }

            s1 = tableWidget_3->item(R, 1)->text();
            s1 = s1.left(2);
            m1 = s1.toInt();

            if ((m1 > 51) && (m1 < 97))
            {
                couleur1 = tableWidget_3->item(R, 1)->background().color();
                if(couleur1 != "#000000") { complete_case(2, Ti2, " ", "#CECECE", couleur1, false, tableWidget_T);}
            }

            s1 = tableWidget_3->item(R, 2)->text();
            s1 = s1.left(2);
            m1 = s1.toInt();
            if ((m1 > 51) && (m1 < 97))
            {
                couleur1 = tableWidget_3->item(R, 2)->background().color();
                if(couleur1 != "#000000") { complete_case(3, Ti2, " ", "#CECECE", couleur1, false, tableWidget_T);}
            }

            s1 = tableWidget_3->item(R, 3)->text();
            s1 = s1.left(2);
            m1 = s1.toInt();
            if ((m1 > 51) && (m1 < 97))
            {
                couleur1 = tableWidget_3->item(R, 3)->background().color();
                if(couleur1 != "#000000") {complete_case(4, Ti2, " ", "#CECECE", couleur1, false, tableWidget_T);}
            }
            Ti2 ++;
        }
        R++;
    }
// ----------------------------------------
    numero_mesure =1; // DEPART

    R=0;
    while ((R < Rmax) && Ti1 < 300)
    {
        sm =tableWidget_3->item(R, 6)->text();

        couleur1 = tableWidget_3->item(R, 6)->background().color();
        if(couleur1 == "#888888")
        {
            s2.setNum(intervalle_t);

            complete_case(0, Ti1-1, s2, "#000000", "#FFFFFF", false, tableWidget_T);
            intervalle_t=0;

            s3.setNum(numero_mesure);
            complete_case(0, Ti1, s3, "#FFFFFF", "#555555", false, tableWidget_T);

            trace_ligne_V(Ti1, numero_mesure);
            s1 = tableWidget_3->item(R, 5)->text();
            duree_note = s1.toInt();
            intervalle_t += duree_note;
            Ti1 += duree_note;
            numero_mesure++;
        }
        else
        {
            s1 = tableWidget_3->item(R, 5)->text(); // durée de la note
            duree_note = s1.toInt();
            intervalle_t += duree_note;
            Ti1 += duree_note;
        }
        R++;
    }
}


//---------------------------------------------------------------------------------------
/*
void MainWindow::gestion_mesures()
{

// sur le tableau vertical
    QString s1, s2;
    int numero_mesure=0;
    int memo_numero_mesure=0;
    int temps=0;
    int duree_i=0;
    int total=0;

    for (int L=0; L<tableWidget_3->rowCount(); L++)
    {
        s1=tableWidget_3->item(L,5)->text();
        duree_i = s1.toInt();

        if (numero_mesure == memo_numero_mesure)
        {
            s2.setNum(total);
            complete_case(L-1, 7, s2, "#000000", "#C4F6FC", false, tableWidget_3);  // BLEU CLAIR
            total += duree_i;
        }


        s1=tableWidget_3->item(L,6)->text();
        numero_mesure = s1.toInt();
        if  ( (numero_mesure % 2) == 0)
        { complete_case(L, 6, s1, "#000000", "#C4F6FC", false, tableWidget_3); }// BLEU CLAIR
        else { complete_case(L, 6, s1, "#000000", "#3AE0F5", false, tableWidget_3); } //BLEU FONCE


        if (numero_mesure != memo_numero_mesure)
        {
            memo_numero_mesure = numero_mesure;
            complete_case(L, 6, s1, "#000000", "#F57900", true, tableWidget_3); // ORANGE
            complete_case(L-1, 7, s2, "#000000", "#C4F6FC", true, tableWidget_3); // BLEU CLAIR
            total = duree_i;
        }
    }
}
*/

int MainWindow::calcul_T_note(int R)
{
// temps du début de la note en fonction du num de ligne (row) de la cellule cliquée dans le tableau3
    int i, di, dT;
    QString s1, duree_txt;

    dT=0;
    for(i=0 ; i<R ; i++)
    {
        duree_txt = tableWidget_3->item(i, 5)->text();
        di = duree_txt.toInt();
        dT += di;
    }
    return dT;
}


QString MainWindow::extraction_data(QString ligne_i, QString label)
{
    int p1, p2, nb;
    QString s1;

    p1=ligne_i.indexOf(label);
    if(p1 == -1) {return "";} // (pas trouvé)

    p2=ligne_i.indexOf(";",p1);
    nb =  label.length();
    s1 = ligne_i.mid(p1+nb, p2-(p1+nb));

    return s1;
}


void MainWindow::calcul_tps()
{
    int duree;
    int total=0;
    QString s1;

    int nb_de_lignes=tableWidget_3->rowCount();
    for (int L=0; L<nb_de_lignes-1; L++)
    {
        duree = tableWidget_3->item(L, 5)->text().toInt();

        s1.setNum(total);

        tableWidget_3->setItem(L, 8, new QTableWidgetItem (s1) );
        total += duree;
        //if (total == 32) {total=0;}
    }
}



int MainWindow::write_Tableau_vertical() // décrypte la 'liste_accords[]'
{
    QString s1, s2;
    int dt;
    int temps=0;
    int total =0;

    //liste_accords.clear();
    int nb_de_lignes = open_fichier_lst(); // appel de la fonction qui peuple la variable (QString) 'liste_accords'
    if (nb_de_lignes == 0) {return 1;}

    init_TW_3();
    tableWidget_3->setRowCount(0);

    mode_depot_note = false;

// -------------------------------------------------------------------------------
// on va transcrire ce contenu du String  "liste_accords"  dans le tableWidget_3

    QString ligne_i;
    for (int L=0; L<nb_de_lignes; L++)
    {
        on_Bt_AddLine_clicked();

        ligne_i=liste_accords[L];

        dechiffre_note("m1=", L, 0);
        dechiffre_note("m2=", L, 1);
        dechiffre_note("m3=", L, 2);
        //dechiffre_note("m4=", L, 3);

        s1= extraction_data(ligne_i, "cmt=");

        complete_case(L, 3, s1, "#000000", "#FFFCDD", false, tableWidget_3);

// la colonne 4 est un bouton

        s1= extraction_data(ligne_i, "d="); // durée
        tableWidget_3->setItem(L, 5, new QTableWidgetItem (s1) ); // dt
        dt = s1.toInt();


        s1= extraction_data(ligne_i, "M="); // mesure
        if (s1 != " ")
        {
            complete_case(L, 6, s1, "#FFFFFF", "#888888", false, tableWidget_3); // 'M' (mesure)

            s1.setNum(temps);
            complete_case(L, 7, s1, "#000000", "#FFFCDD", false, tableWidget_3); // tps
            temps =0;
        }
        else
        {
            s1.setNum(temps);
            complete_case(L, 7, s1, "#000000", "#CECECE", false, tableWidget_3); // 'M' (mesure)
        }
        temps += dt;

        tableWidget_3->setItem(L, 8, new QTableWidgetItem (" "));


        s1= extraction_data(ligne_i, "a="); // ACC
        tableWidget_3->setItem(L, 9, new QTableWidgetItem (s1));

        s1= extraction_data(ligne_i, "cases=");
        complete_case(L, 10, s1, "#000000", "#FFFFFF", false, tableWidget_3);

        s2="";
        bool ok = false;

        s1= extraction_data(ligne_i, "D0v=");  // corde à vide
        if ((s1 != "") && (s1 != "-"))  { s2 += "D0v=" + s1 + ";"; ok = true; }

        s1= extraction_data(ligne_i, "D0h=");  // corde à vide
        if ((s1 != "") && (s1 != "-")) { s2 += "D0h=" + s1 + ";"; ok = true; }

        s1= extraction_data(ligne_i, "D1v=");  // posiion "verticale" (c.d corde) du doigt 1 (index)
        if ((s1 != "") && (s1 != "-"))  { s2 += "D1v=" + s1 + ";"; ok = true; }

        s1= extraction_data(ligne_i, "D1h=");  // posiion "horizontale" (case) du doigt 1 (index)
        if ((s1 != "") && (s1 != "-")) { s2 += "D1h=" + s1 + ";"; ok = true; }

        s1= extraction_data(ligne_i, "D2v=");
        if ((s1 != "") && (s1 != "-")) { s2 += "D2v=" + s1 + ";"; ok = true; }

        s1= extraction_data(ligne_i, "D2h=");
        if ((s1 != "") && (s1 != "-")) { s2 += "D2h=" + s1 + ";"; ok = true; }

        s1= extraction_data(ligne_i, "D3v=");
        if ((s1 != "") && (s1 != "-")) { s2 += "D3v=" + s1 + ";"; ok = true; }

        s1= extraction_data(ligne_i, "D3h=");
        if ((s1 != "") && (s1 != "-")) { s2 += "D3h=" + s1 + ";"; ok = true; }

        s1= extraction_data(ligne_i, "D4v=");
        if ((s1 != "") && (s1 != "-")) { s2 += "D4v=" + s1 + ";"; ok = true; }

        s1= extraction_data(ligne_i, "D4h=");
        if ((s1 != "") && (s1 != "-")) { s2 += "D4h=" + s1 + ";"; ok = true; }

        if (ok != true) {s2=" ";}
        QTableWidgetItem *item1 = new QTableWidgetItem();
        item1->setText(s2);
        item1->setFlags(item1->flags() &  ~Qt::ItemIsEditable); // passe en read only
        tableWidget_3->setItem(L, 11, item1);
    }
    tableWidget_3->resizeColumnsToContents();
    return 0;
}


void MainWindow::on_Bt_Load_lst_clicked()
{
    set_zoom2();
    int w = write_Tableau_vertical();
    if (w==0)
    {
        //checkBox_not_erase->setChecked(true);
        //gestion_mesures();
        write_Time_line();
    }
}


void MainWindow::on_Bt_Supp_line_clicked()
{
    int R= tableWidget_3->currentRow();
    tableWidget_3->removeRow(R);
}



void MainWindow::complete_ligne(int R)
{
    tableWidget_3->setItem(R, 0, new QTableWidgetItem (" ") ); // note1
    tableWidget_3->setItem(R, 1, new QTableWidgetItem (" ") ); // note2
    tableWidget_3->setItem(R, 2, new QTableWidgetItem (" ") ); // note3

    tableWidget_3->setItem(R, 3, new QTableWidgetItem (" ") ); // cmt

    QTableWidgetItem *Item1 = new QTableWidgetItem();
    Item1->setIcon(QIcon("../images/01.png" ));
    tableWidget_3->setItem(R, 4, Item1 ); // bouton

    tableWidget_3->setItem(R, 5, new QTableWidgetItem (" ") ); // dt
    tableWidget_3->setItem(R, 6, new QTableWidgetItem (" ") ); // M
    tableWidget_3->setItem(R, 7, new QTableWidgetItem (" ") ); // tps
    tableWidget_3->setItem(R, 8, new QTableWidgetItem (" ") ); // tot
    tableWidget_3->setItem(R, 9, new QTableWidgetItem (" ") ); // ACC (accord type)
    tableWidget_3->setItem(R, 10, new QTableWidgetItem (" ") ); // intervalle de cases (sur le manche) à jouer
    tableWidget_3->setItem(R, 11, new QTableWidgetItem (" ") ); // doigts
}



void MainWindow::on_Bt_AddLine_clicked() // à la fin
{
    int R=tableWidget_3->rowCount();

    tableWidget_3->setRowCount(R+1);
    complete_ligne(R);
}


void MainWindow::on_Bt_AddLine_ici_clicked() // ici
{
    int R= tableWidget_3->currentRow();
    tableWidget_3->insertRow(R);
    complete_ligne(R);
}




void MainWindow::on_pushButton_2_clicked()
{
    on_Bt_save_clicked();
    init_TW_3();
    lineEdit_2->clear();
    lineEdit_12->clear();
    lineEdit_13->clear();
}


void MainWindow::joue_morceau_debut()
{
    //if(nb_lignes ==0){return;}
    if (lecture_pause == 1)
    {
        Bt_lecture_2->setText("joue > debut");
        //Bt_lecture_2->setStyleSheet("QPushButton{background-color:#50FF1B;}");
        lecture_pause =0;
        QString s1;
        s1.setNum(num_ligne_en_cours);// conversion num -> txt
        Timer2->stop();
    }
    else
    {
        nb_notes_jouees_max = 10000;
       // Bt_lecture_2->setText("[]");
        //Bt_lecture_2->setStyleSheet("QPushButton{background-color:yellow;}");
        lecture_pause = 1;
        //num_note_stop=10000;
        Tp1=0;
        temps1=0;
        Timer2->start(10);
    }
}


void MainWindow::joue_morceau_ici(int R, int nb_notes)
{
    //if(nb_lignes ==0){return;}


    num_ligne_en_cours = R-1;
    //num_colonne_a_encadrer = R;
    nb_notes_jouees_max = nb_notes-1;
    nb_notes_jouees = 0;

    //tableWidget_3->selectRow(lineEdit_7->text().toInt());
   //R = tableWidget_3->currentRow();
   R = lineEdit_9->text().toInt();
   int T1 = calcul_T_note(R-1);
   // num_colonne_a_encadrer = 3; //T1;
    Tp1=T1;
    temps1=T1;


    if (lecture_pause == 1)
    {
        //Bt_lecture_1->setText("joue > ici");
        //Bt_lecture_1->setStyleSheet("QPushButton{background-color:#50FF1B;}");
        lecture_pause =0;
       // QString s1;
       // s1.setNum(num_ligne_en_cours);// conversion num -> txt
        Timer2->stop();
        //Edit_1->setText(s1);
    }
    else
    {
        //Bt_lecture_1->setText("[]");
        //Bt_lecture_1->setStyleSheet("QPushButton{background-color:yellow;}");
        lecture_pause = 1;
        //num_note_stop=10000;
        Timer2->start(300);
    }
}


void MainWindow::on_Bt_lecture_1_clicked() // joue ici
{
    int R=lineEdit_9->text().toInt();
    nb_notes_jouees_max = spinBox_nb_notes->value();
    joue_morceau_ici(R, nb_notes_jouees_max);
}



void MainWindow::on_Bt_lecture_2_clicked() // joue depuis le début
{
    num_ligne_en_cours =0;
   // num_note_max = liste_NOTES_importees.length()-1;

    num_note_max = tableWidget_3->rowCount();
    if (num_note_max < 1) {return;}
    joue_morceau_debut();
}


void MainWindow::on_Bt_lecture_3_clicked() // joue 1 note
{
    int n0 = num_ligne_en_cours;
    //QString s1;
    //s1.setNum(n0);
    //lineEdit_9->setText(s1);
    //int R=lineEdit_9->text().toInt();
    joue_morceau_ici(n0, 1);
    num_ligne_en_cours ++;
}


void MainWindow::on_Bt_STOP_clicked()
{
    Bt_lecture_2->setText("joue > debut");
    lecture_pause =0;
    QString s1;
    s1.setNum(num_ligne_en_cours);
    Timer2->stop();
}



void MainWindow::create_100_lignes_V()
{
    for (int n=0; n<100; n++)
    {
         lst_frames.append(new QFrame(this));
         lst_frames[n]->setGeometry(0, 0, 1, 1);
         //lst_frames[n]->setStyleSheet(QString::fromUtf8("background-color: rgb(0, 0, 0);"));
         lst_frames[n]->setStyleSheet("background-color: blue");
         lst_frames[n]->hide();
    }
}


void MainWindow::trace_ligne_V(int num_colonne, int num_mesure)
{
//sur le tableau horizontal (TimeLine)

    if (num_mesure >=100) {return;} // nb max de lignes instanciées, voir fonction ci-dessus

    int x;
    int dy=140;
    int LC=10; // largeur colonnes
    int H_diff;
    int x0=tableWidget_T->x();
    int y0=tableWidget_T->y();

    if (zoom==1) {LC=10;}
    if (zoom==2) {LC=20;}

    QScrollBar *H_Scroll = tableWidget_T->horizontalScrollBar();

    H_diff = num_colonne - H_Scroll->value();
    x = x0 + LC * H_diff;

    if (H_diff>=0)
    {
        lst_frames[num_mesure+8]->setGeometry(QRect(x, y0, 2, dy));
        lst_frames[num_mesure+8]->setStyleSheet("background-color: gray");
        lst_frames[num_mesure+8]->show();
    }
}



void MainWindow::trace_rectangle1(int x, int y, int dx, int dy)
{
    lst_frames[1]->setGeometry(QRect(x, y, dx, 2));     lst_frames[1]->show();
    lst_frames[2]->setGeometry(QRect(x, y+dy, dx, 2));  lst_frames[2]->show();

    lst_frames[3]->setGeometry(QRect(x, y, 2, dy));     lst_frames[3]->show();
    lst_frames[4]->setGeometry(QRect(x+dx, y, 2, dy));  lst_frames[4]->show();
}



void MainWindow::trace_rectangle2(int x, int y, int dx, int dy)
{
// l'objet QRect doit s'utiliser sur un QPainter
// d'où cette fonction qui trace directement sur le mainwindow
// sans masquage du fond (ne confisque pas les clics souris sur les widgets en particulier !!!)
    lst_frames[5]->setGeometry(QRect(x, y, dx, 2));     lst_frames[5]->show();
    lst_frames[6]->setGeometry(QRect(x, y+dy, dx, 2));  lst_frames[6]->show();

    lst_frames[7]->setGeometry(QRect(x, y, 2, dy));     lst_frames[7]->show();
    lst_frames[8]->setGeometry(QRect(x+dx, y, 2, dy));  lst_frames[8]->show();
}




void MainWindow::encadrement_colonne() // de la timeline en bas (tableWidget_T)
{
// rappel :  label_timeline->setGeometry(10, 830, 100, 30);

    int x0=tableWidget_T->x();
    int y0=tableWidget_T->y();
    int x;
    int dx;
    int dy=120; //tableWidget_T->height();
    int LC=10; // largeur colonnes, doit coincider avec la valeur inscrite dans l'ui
    int HSB;
    int H_diff;

    //num_colonne_a_encadrer=5;
    //nb_colonnes_a_encadrer=3;

    if (zoom==1) {LC=10;}
    if (zoom==2) {LC=20;}
    // nb_colonnes_a_encadrer -> variable globale

    QScrollBar *H_Scroll = tableWidget_T->horizontalScrollBar();

    HSB = H_Scroll->value();
    H_diff = num_colonne_a_encadrer - HSB;

    x = x0 + LC * H_diff;
    dx =  LC * nb_colonnes_a_encadrer;

    if (H_diff>=0)
    {
        trace_rectangle2(x, y0, dx, dy);
    }
    else
    {
        ;
    }
}



void MainWindow::encadrement_ligne() // du tableWidget_3
{
    int x0=tableWidget_3->x();
    int y0=tableWidget_3->y() + 22;
    int y_max = y0 + tableWidget_3->height();

    int x, y;
    int largeur = tableWidget_3->width()-18;
    int HL = tableWidget_3->verticalHeader()->defaultSectionSize();
    int V_SB;
    int V_diff;

// encadrement de la ligne sélectionnée
    int num_ligne = tableWidget_3->currentRow();
    QScrollBar *V_Scroll = tableWidget_3->verticalScrollBar();

    V_SB = V_Scroll->value();
    V_diff = num_ligne - V_SB;

    x = x0;
    y = y0 + HL * V_diff;

    if ((V_diff>=0) && (y < y_max - HL))
    {
        trace_rectangle1(x, y, largeur, HL);
    }
    else { trace_rectangle1(x,y, 1, 1); }
}


void MainWindow::TW_T_scroll(int H)
{

  write_Time_line();
  encadrement_colonne();

}

void MainWindow::TW_3_scroll(int H)
{

    //write_Time_line();
    encadrement_ligne();

}



void MainWindow::on_Bt_refresh_clicked()
{
    init_TW_T();
    create_100_lignes_V();
}


void MainWindow::set_zoom1()
{
    zoom=1;

    QFont fnt;
    fnt.setFamily("Ubuntu");
    fnt.setPointSize(6);
    tableWidget_T->setFont(fnt);

    for(int n=0; n<100; n++)
    {
        tableWidget_T->setColumnWidth(n, 10);
    }
}


void MainWindow::set_zoom2()
{
    zoom=2;

    QFont fnt;
    int n_max = tableWidget_T->columnCount();

    fnt.setFamily("Ubuntu");
    fnt.setPointSize(8);
    tableWidget_T->setFont(fnt);

    for(int n=0; n<n_max; n++)
    {
        tableWidget_T->setColumnWidth(n, 20);
    }

}

void MainWindow::on_radioButton_Z1_clicked()
{
    set_zoom1();
}


void MainWindow::on_radioButton_Z2_clicked()
{
    set_zoom2();
}




void MainWindow::on_Bt_open_dossier_clicked()
{
    QString s1, path1;
    int p1;
/*
    s1 = lineEdit_1->text();
    p1 = s1.lastIndexOf("/");
    s1.remove(p1, 255);
    path1 = s1;
*/
    path1 =  string_currentDir;

    QProcess process1;
    process1.setProgram("caja");
    process1.setArguments({path1});
    process1.startDetached();
}





void MainWindow::on_spinBox_4_valueChanged(int arg1)
{
    QString s3, s4;
    case_min = arg1;

    if (arg1 > case_max) {spinBox_5->setValue(arg1);}
    s3.setNum(case_min);

    case_max = spinBox_5->value();
    s4.setNum(case_max);
    lineEdit_14->setText(s3 + "a" +s4);

    encadre_accord(case_min, case_max);

    //complete_accord(case_min, case_max);  // NON !! pas ici !!!!

}


void MainWindow::on_spinBox_5_valueChanged(int arg1)
{
    QString s3, s4;

    case_min = spinBox_4->value();

    if (arg1 < case_min) {spinBox_5->setValue(case_min);}

    s3.setNum(case_min);

    case_max = arg1;
    s4.setNum(case_max);

    lineEdit_14->setText(s3 + "a" +s4);

    encadre_accord(case_min, case_max);

    //complete_accord(case_min, case_max); // NON !! pas ici !!!!
}


void MainWindow::on_pushButton_4_clicked()
{
    QString s1;

    int R = tableWidget_3->currentRow();


    s1=lineEdit_10->text();
    if (s1 != "")
    {
        tableWidget_3->setItem(R, 9, new QTableWidgetItem (s1) );

        s1=lineEdit_14->text();
        tableWidget_3->setItem(R, 10, new QTableWidgetItem (s1) );
    }
    else
    {
        QMessageBox msgBox;
        msgBox.setText("Choisir le type (Maj, Min, 7e de dom... au préalable)");
        msgBox.exec();
    }
}


/* RAPPEL :
struct NOTE_importee
{
    uint16_t numero;  // 2 octets
    uint8_t midi;     // 1 octet
    uint16_t n_barre; // 2 octets ; numéro de la barre temporelle sur laquelle est posée la note
    uint8_t n_temps;  // 1 octet  ; 1..16 numéro du temps (temps fort, temps faible) au sein de la mesure
    uint8_t duree;    // 1 octet  ; en nb d'intervalles de barres
// total 7 octets
};

*/

void MainWindow::analyse_notes_importees() // (depuis le prog FFT) et garnit le TW3
{
    NOTE_importee note_i1, note_i2;
   // int midi_i;
    //int b1, b2;
    int n_barre_1;
    int n_barre_2;
    int temps=0;
    int total=0;
    float dt_b;
   // int nb_notes;
    QString s1;

    uint8_t  midi_note1;
    uint8_t  midi_note2;
   // int R=0;

  //  int numero_note;
    uint32_t t=0;
    //int duree_note;

    int num_case=0;
    int num_ligne=0;
    int num_mesure=0;
    QString nom_note;

    int n_max = liste_NOTES_importees.length();


    //on_Bt_AddLine_clicked();
   // num_ligne++;

    for(int n=0; n<n_max; n++)
    {
// QMessageBox msgBox; QString s1; s1 = "..."; msgBox.setText(s1); msgBox.exec();

        note_i1 = liste_NOTES_importees[n];
        note_i2 = liste_NOTES_importees[n+1];

        n_barre_1 = note_i1.n_barre;
        n_barre_2 = note_i2.n_barre;

        dt_b = n_barre_2 - n_barre_1;
        if (dt_b <0) {dt_b = 8;}

        midi_note1 = liste_NOTES_importees[n].midi;
        midi_note2 = liste_NOTES_importees[n+1].midi;

        nom_note.setNum(midi_note1);
        int h1 = calcul_hauteur_note(midi_note1);
        h1-=3;
        if(h1<0){h1+=12;}
        if(h1>11){h1-=12;}
        QColor couleur1 = liste_couleurs[h1];

        if (h1>=0)
        {
            nom_note += " ";
            nom_note += gamme_chromatique[h1];
        }

        if (dt_b == 0)
        {
            complete_case(num_ligne, num_case, nom_note, "#000000", couleur1, false, tableWidget_3);
            num_case++;
            if (num_case >3) {num_case = 3;}
         }

        if (dt_b != 0)
        {
            complete_case(num_ligne, num_case, nom_note, "#000000", couleur1, false, tableWidget_3);
            s1.setNum(dt_b);
            tableWidget_3->setItem(num_ligne, 5, new QTableWidgetItem(s1)); // dur (durée)

            temps = note_i1.n_temps;
            s1.setNum(temps);
            tableWidget_3->setItem(num_ligne-1, 7, new QTableWidgetItem(s1)); // tps
            on_Bt_AddLine_clicked();
            num_ligne++;
            num_case=0;
        }

        s1.setNum(temps);
        tableWidget_3->setItem(num_ligne-1, 7, new QTableWidgetItem(s1)); // tps


        if ((temps == 32) && (dt_b !=0))
        {
            num_mesure++;
            s1.setNum(num_mesure);
            complete_case(num_ligne-1, 6, s1, "#000000", "#FFFCDD", false, tableWidget_3); // M
        }
    }

    tableWidget_3->resizeColumnsToContents();

    s1.setNum(0);
    lineEdit_12->setText(s1);

    s1.setNum(num_ligne);
    lineEdit_13->setText(s1);
}


void MainWindow::supprime_note(int n)
{
   //int z1= liste_NOTES.length();

   liste_NOTES_importees.remove(n);
   //effacer_calque(scene4,calque_notes);
   //tri_liste_notes_par_num_barre(); //les notes seront triées par temps croissant
  // numerotation_liste_notes(); //les notes seront numérotées par temps croissant
   //affiche_liste_notes();
   //trace_liste_notes();

   //int z2= liste_NOTES_importees.length();
}



void MainWindow::suppression_notes_invalides()
{
    int midi;
    int n_max = liste_NOTES_importees.length();
    int nb = 0;

    bool boucler=true;
    do
    {
        nb=0;
        for(int n=0; n<n_max; n++)
        {
            midi = liste_NOTES_importees[n].midi;
            if ((midi <40) || (midi>82)) // midi=100 code pour les barres de mesures
            {
                supprime_note(n);
                n_max --;
                nb++;
            }
        }
        if (nb==0) {boucler=false;}
    }
    while (boucler == true);
}


void MainWindow::import_fichier_NOTES() // généré par le programme FFT
{
    QString filename1;
    QString s1;

    //int p1= string_currentFile.lastIndexOf('/');
    //string_currentDir = string_currentFile.left(p1);

    filename1 = QFileDialog::getOpenFileName(this,
        tr("Ouvrir Fichier nts"), string_currentDir+"/", tr("Fichiers nts (*.nts)"));

    file_dat.setFileName(filename1);
    if (!file_dat.open(QIODevice::ReadOnly))
    {
        data_ok = false;
        return ;
    }
    else
    {
        binStream1.setDevice(&file_dat); // accès à la totalité du fichier dat
        binStream1.setVersion(QDataStream::Qt_6_8);
        data_ok = true;
    }

   // int z = sizeof(NOTE); // ATTENTION ! ne PAS utiliser cette valeur qui tient en compte l'alignement en RAM
    long n_max = file_dat.bytesAvailable() / 7; // 7 bits par enr; voir la def de 'NOTE' dans le .h

    double  x;
    double dx;
    double vts;

    // lecture entête -----------------
    binStream1 >> x >> dx >> vts;  // 8+8+8=24 octets au début du fichiers

 //   qDebug() << "vts" << vts;

    uint8_t xx;
    for (int i=0; i<(64-24); i++) {binStream1 >> xx;} // lit en tout à 64 octets
    //---------------------------------

    doubleSpinBox_vitesse->setValue(vts);
    s1.setNum(x);
    lineEdit_x->setText(s1);
    s1.setNum(dx);
    lineEdit_dx->setText(s1);

    NOTE_importee note_i;
    for(int n=0; n<n_max; n++)
    {
        binStream1 >> note_i.numero >> note_i.midi >> note_i.n_barre >> note_i.n_temps >> note_i.duree;
        note_i.midi += spinBox_transposition->value();
        liste_NOTES_importees << note_i;
    }
    file_dat.close();
}




void MainWindow::on_Bt_copie_doigts_to_TW3_clicked()
{
// le 'tableWidget_doigts' c'est le tableau de saisie dans le cadre 'Position des doigts'

    QString s1, s_out;;
    s1 = tableWidget_doigts->item(0,0) ->text();
    if (s1 != "-") {s_out += "D0v=" + s1 + ";";}
    s1 = tableWidget_doigts->item(0,1) ->text();
    if (s1 != "-") {s_out += "D0h=" + s1 + ";";}

    s1 = tableWidget_doigts->item(1,0) ->text();
    if (s1 != "-") {s_out += "D1v=" + s1 + ";";}
    s1 = tableWidget_doigts->item(1,1) ->text();
    if (s1 != "-") {s_out += "D1h=" + s1 + ";";}

    s1 = tableWidget_doigts->item(2,0) ->text();
    if (s1 != "-") {s_out += "D2v=" + s1 + ";";}
    s1 = tableWidget_doigts->item(2,1) ->text();
    if (s1 != "-") {s_out += "D2h=" + s1 + ";";}

    s1 = tableWidget_doigts->item(3,0) ->text();
    if (s1 != "-") {s_out += "D3v=" + s1 + ";";}
    s1 = tableWidget_doigts->item(3,1) ->text();
    if (s1 != "-") {s_out += "D3h=" + s1 + ";";}

    s1 = tableWidget_doigts->item(4,0) ->text();
    if (s1 != "-") {s_out += "D4v=" + s1 + ";";}
    s1 = tableWidget_doigts->item(4,1) ->text();
    if (s1 != "-") {s_out += "D4h=" + s1 + ";";}

    QTableWidgetItem *item1 = new QTableWidgetItem();
    item1->setText(s_out);
    item1->setFlags(item1->flags() &  ~Qt::ItemIsEditable);
    tableWidget_3->setItem(ligne_TW3, 11, item1); // recopie le résultat dans le grand tableau TW3 de droite

    affi_positions_doigts_dans_status(s_out);
}


void MainWindow::on_pushButton_6_clicked()
{
    QMessageBox msgBox;
    QString s1;

    s1 = "POSITION DES DOIGTS main gauche (sur le manche)";
    s1 += "\n";
    s1 += "\n";
    s1 += "La première ligne (0) désigne la corde à vide";
    s1 += "\n";

    s1 += "Chacune des 4 lignes suivantes (1 à 4) représente un doigt :";
    s1 += "\n";
    s1 += "le numéro de la ligne désigne le doigt :";
    s1 += "\n";
    s1 += "doigt 1 = index, 2 = majeur...";
    s1 += "\n";
    s1 += "Pour écrire dans le tableau cliquer au préalable sur une note (sur le manche)";
    s1 += "\n";
    s1 += "... puis ici sur une ligne (sur une des 4 petites flèches vertes)";
    s1 += "\n";
    s1 += "( corde 1 = mi aigü...)";
    s1 += "\n";
    s1 += "\n";
    s1 += "Le tableau s'actualise également lorsqu'une note est jouée depuis la liste TW3";
    s1 += "\n";
    s1 += "\n";
    s1 += "Dès lors, sur le manche, les numéros des doigts s'afficheront au centre des notes "
          "pressées dans les cases (et pas forcément jouées, on peut très bien plaquer tout un "
          "accord et ne jouer qu'une note à la fois, en arpège )";

    msgBox.setText(s1);
    msgBox.exec();


}


void MainWindow::on_tableWidget_doigts_cellClicked(int row, int column)
{
    QString s1, s2;

    if(case_jouee == 0)
    {
        s1.setNum(corde_jouee);
        tableWidget_doigts->item(0, 0)->setText(s1);
        return ;
    }

    if (column==2)
    {
        s1.setNum(corde_jouee);
        tableWidget_doigts->item(row, 0)->setText(s1);
        s2.setNum(case_jouee);
        tableWidget_doigts->item(row, 1)->setText(s2);

    }
}


void MainWindow::on_Bt_RAZ_doigts_clicked()
{
    //tableWidget_doigts->clear();
    init_tableWidget_doigts();
}


void MainWindow::on_pushButton_7_clicked()
{
    QMessageBox msgBox;
    QString s1;
    s1 = "AIDE GENERALE";
    s1 += "\n";
    s1 += "\n";
    s1 += "1- Ouvrir un 'fichier accords' préalablement sauvegardé avec ce logiciel 'Guitare'";
    s1 += "\n";
    s1 += "Variante : Importer la liste des notes créée avec le logiciel 'FFT'";
    s1 += "\n";
    s1 += "2- vérifier la durée (calculée) des mesures et modifier la durée des notes si nécessaire";
    s1 += "\n";
    s1 += "3- Pour chaque ligne, configurer un accord type ou une 'note seule'";
    s1 += "(utiliser pour cela le 'Configurateur d'accords')";
    s1 += " puis envoyer la configuration obtenue vers le tableau TW3, avec le bouton 'to TW3 -->' du 'configurateur d'Accords'";
    s1 += "\n";
    s1 += "4- Reste à choisir les doigts pour chaque note. Voir l'aide du cadre 'Position des doigts'";
    s1 += "\n";
    s1 += "\n";
    s1 += "VARIANTE :";
    s1 += "\n";
    s1 += "\n";
    s1 += "On peut aussi partir de zéro et entrer les notes une à une manuellement dans TW3 (TableWidget 3)";
    s1 += "\n";
    s1 += "Il est fortement conseillé de cliquer les notes sur le manche au préalable (voir l'aide du manche) ";
    s1 += "plutôt que de saisir les libellés au clavier, afin d'éviter les saisies incorrectes";
    msgBox.setText(s1);
    msgBox.exec();
}





void MainWindow::contextMenuEvent(QContextMenuEvent *event) // menu contextuel (c.a.d déclenché par le clic de droite)
{
// statusbar->showMessage("clic de droite");
    int x_min, x_max;
    int y_min, y_max;

    x_min = graphicsView1->x();
    x_max = x_min + graphicsView1->width();

    y_min = graphicsView1->y();
    y_max = y_min + graphicsView1->height();

    if (x_clic_ecran > x_min && x_clic_ecran < x_max && y_clic_ecran > y_min && y_clic_ecran < y_max)
    {
        QString  s1, s2;
        s1.setNum(n_midi_jouee);

        s2 = "mode: DEPOT NOTE ("+ s1 + ") -> ";
        s2 += lineEdit_note->text();
        s2 += " cliquez maintenant dans une case de TW3 pour placer la note";

        mode_depot_note = true;
        statusbar->showMessage(s2);
        MainWindow::setCursor(Qt::CrossCursor);
    }
}


void MainWindow::on_pushButton_8_clicked()
{
    QMessageBox msgBox;
    QString s1;
    s1 = "COPIE d'une note vers le tableau TW3   -->";
    s1 += "\n";
    s1 += "\n";
    s1 += "1- clic-droit sur une note (sur le manche)";
    s1 += "\n";
    s1 += "Le curseur de la souris devient une croix";
    s1 += "\n";
    s1 += "2- cliquer_gauche alors dans une case de TW3 (colonnes 1 à 3)";
    s1 += "\n";
    s1 += "La note est alors collée dans le tableau";
    s1 += "\n";
    s1 += "\n";
    s1 += "Si clic en dehors du tableau, l'opéraion est annulée";
    s1 += "\n";

    msgBox.setText(s1);
    msgBox.exec();
}

void MainWindow::on_pushButton_9_clicked()
{
    QMessageBox msgBox;
    QString s1;
    s1 = "Les numéros qui s'affichent au centre des notes jouées sont ceux des doigts de la main gauche";
    s1 += "\n";
    s1 += "1=index, 2=majeur, 3=annulaire, 4=auriculaire";


    msgBox.setText(s1);
    msgBox.exec();
}




void MainWindow::on_pushButton_10_clicked()
{
    QMessageBox msgBox;
    QString s1;
    s1 = "Les fichiers sont enregistrés au format texte";
    s1 += "\n";
    s1 += "Il peuvent être facilement concaténés avec un éditeur de texte";
    s1 += "\n";
    s1 += "pour obtenir un morceau complet à partir de petites séquences.";

    msgBox.setText(s1);
    msgBox.exec();
}


void MainWindow::on_Bt_import_notes_clicked()
{
    init_TW_3();
    liste_NOTES_importees.clear();
    import_fichier_NOTES();
    suppression_notes_invalides();
    affiche_liste_notes();
    analyse_notes_importees(); // et garnit le TW3
}


void MainWindow::complete_accord(int c_min, int c_max)
{
    spinBox_4->setValue(c_min);
    case_min = c_min;

    spinBox_5->setValue(c_max);
    case_max = c_max;

    if (type_accords == 1) {on_Bt_ACCORD_1_clicked();}
    if (type_accords == 2) {on_Bt_ACCORD_2_clicked();}
    if (type_accords == 3) {on_Bt_ACCORD_3_clicked();}
}



void MainWindow::on_pushButton_3_clicked()
{
    complete_accord(0, 20);
}



void MainWindow::on_pushButton_3a_clicked()
{
    complete_accord(9, 12);
}


void MainWindow::on_pushButton_3b_clicked()
{
    complete_accord(7, 10);
}


void MainWindow::on_pushButton_3c_clicked()
{
    complete_accord(5, 8);
}


void MainWindow::on_pushButton_3d_clicked()
{
    complete_accord(3, 6);
}


void MainWindow::on_pushButton_3e_clicked()
{
    complete_accord(0, 3);
}


void MainWindow::on_pushButton_11_clicked()
{
    QMessageBox msgBox;
    QString s1;
    s1 =  "Cliquer sur bouton vert 'Import notes' pour remplir le tableau";
    s1 += "\n";
    s1 += "\n";
    s1 += "n° barre (de fraction 1/16 de mesure) est comptée depuis le début.";
    s1 += "\n";
    s1 += "'temps'= numéro de barre au sein de chaque mesure.";
    s1 += "\n";
    s1 += "'durée' est exprimée en nb de barres.";
    s1 += "\n";

    msgBox.setText(s1);
    msgBox.exec();
}


void MainWindow::on_tableWidget_3_cellChanged(int row, int column)
{
    if (column==5) {calcul_tps();}
}


void MainWindow::choix_dossier_de_travail()
{

    QString currentDir_actuel = string_currentDir;
    string_currentDir = QFileDialog::getExistingDirectory
            (this, tr("Open Directory"), currentDir_actuel, QFileDialog::ShowDirsOnly  | QFileDialog::DontResolveSymlinks);

    if (string_currentDir != "")
    {
        string_currentDir += "/";
        dossier_de_travail_ok = true;
        save_fichier_ini();
        lineEdit_current_dir->setText(string_currentDir);
    }
    else
    {
        string_currentDir = currentDir_actuel;
        dossier_de_travail_ok = false;
    } // -> si on clique sur le bouton 'cancel'
}



void MainWindow::on_Bt_choix_current_dir_clicked()
{
    choix_dossier_de_travail();
}




void MainWindow::on_Bt_save_ACD_clicked()
{
    QString chemin_out;
    chemin_out = string_currentDir;
    QFile file1(chemin_out + "ACD" + ".txt");
    QString sA, sC, sD;
    int n_max = tableWidget_3->rowCount();

    if (file1.open(QIODevice::WriteOnly | QIODevice::Text))
    {
        QTextStream file_out(&file1);

        for (int n=0; n<n_max; n++)
        {
            sA = tableWidget_3->item(n, 9)->text(); // accords
            sC = tableWidget_3->item(n, 10)->text(); // cases
            sD = tableWidget_3->item(n, 11)->text(); // doigts

            file_out << "A=" + sA + ";" + "C=" + sC + ";" + "D=" + sD + ";";
            file_out << char(10);
        }

    }
    file1.close();

    QMessageBox msgBox;
    QString s1="Fichier enregistré: " + chemin_out + "ACD" + ".txt";
    msgBox.setText(s1);
    msgBox.exec();
}


int MainWindow::on_Bt_load_ACD_clicked()
{
    QString chemin_in;
    chemin_in = string_currentDir;
    QFile file1(chemin_in + "ACD" + ".txt");
    QString sA, sC, sD;
    QString ligne_i;
    int num_ligne=0;

    if (!file1.open(QIODevice::ReadOnly | QIODevice::Text)) return 1;
    QTextStream TextStream1(&file1);

    while ( !TextStream1.atEnd() )
    {
        ligne_i = TextStream1.readLine();
        tableWidget_3->item(num_ligne, 8)->setText(" ");
        sA= extraction_data(ligne_i, "A="); tableWidget_3->item(num_ligne, 9)->setText(sA);
        sC= extraction_data(ligne_i, "C="); tableWidget_3->item(num_ligne, 10)->setText(sC);
        sD= extraction_data(ligne_i, "D="); tableWidget_3->item(num_ligne, 11)->setText(sD);
        num_ligne++;
    }
    file1.close();

    return 0;
}


void MainWindow::on_Bt_calcul_tps_clicked()
{
    calcul_tps();
}


void MainWindow::on_pushButton_12_clicked()
{
    QMessageBox msgBox;
    QString s1;
    s1 = "ABBREVIATIONS, sigles utilisés";    s1 += "\n";
    s1 += "dans la colonne Cmt ->";    s1 += "\n";
    s1 += "\n";
    s1 += "(GL = début glissendo";    s1 += "\n";
    s1 += "GL) = fin glissendo";    s1 += "\n";
    s1 += "HO = Hammer-On";    s1 += "\n";
    s1 += "PO = Pull-Off";    s1 += "\n";
    s1 += "pB = petit Barré (cordes 1-2-3)";    s1 += "\n";
    msgBox.setText(s1);
    msgBox.exec();
}


void MainWindow::on_Bt_sigle_1_clicked()
{
    complete_case(num_ligne_en_cours, 3, "(GL", "#000000","#FFFCDD", false, tableWidget_3);
}


void MainWindow::on_Bt_sigle_2_clicked()
{
    complete_case(num_ligne_en_cours, 3, "GL)", "#000000","#FFFCDD", false, tableWidget_3);
}


void MainWindow::on_Bt_sigle_3_clicked()
{
    complete_case(num_ligne_en_cours, 3, "(HO", "#000000","#FFFCDD", false, tableWidget_3);
}


void MainWindow::on_Bt_sigle_4_clicked()
{
    complete_case(num_ligne_en_cours, 3, "HO)", "#000000","#FFFCDD", false, tableWidget_3);
}


void MainWindow::on_Bt_sigle_5_clicked()
{
    complete_case(num_ligne_en_cours, 3, "Ba", "#000000","#FFFCDD", false, tableWidget_3);
}


void MainWindow::on_Bt_sigle_9_clicked()
{
    complete_case(num_ligne_en_cours, 3, "PO", "#000000","#FFFCDD", false, tableWidget_3);
}


void MainWindow::on_Bt_sigle_10_clicked()
{
    complete_case(num_ligne_en_cours, 3, "Ba", "#000000","#FFFCDD", false, tableWidget_3);
}


void MainWindow::on_pushButton_clicked()
{
    encadre_accord(spinBox_4->value(), spinBox_5->value());
}

