#ifndef MainWindow_H
#define MainWindow_H

// #include <QMW>
#include "ui_MainWindow.h"
#include <QtWidgets/QLabel>
#include <QGraphicsView>
#include <QTableWidget>
#include <QPushButton>

#include <QLine>
#include <QFrame>

#include <QtMultimedia/QMediaPlayer>
#include <QAudioOutput>
#include <QTimer>

QT_BEGIN_NAMESPACE
namespace Ui { class MW; }
QT_END_NAMESPACE


struct NOTE
{
    uint8_t hauteur; // 0=Do 1=Do#...
    uint8_t duree;
};


struct MESURE
{
   uint16_t numero;
   uint16_t num_1ere_note;
   uint16_t num_last_note;
   uint8_t nb_notes;
};



struct NOTE_importee
{
    uint16_t numero;  // 2 octets
    uint8_t midi;     // 1 octet
    uint16_t n_barre; // 2 octets ; numéro de la barre temporelle sur laquelle est posée la note
    uint8_t n_temps;  // 1 octet  ; numéro du temps (temps fort, temps faible) au sein de la mesure
    uint8_t duree;    // 1 octet  ; en nb d'intervalles de barres
// total 7 octets
};


class MainWindow : public QMainWindow, public Ui::MainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

    void mousePressEvent(QMouseEvent *event);

    void contextMenuEvent(QContextMenuEvent *event);

    void init_TW_3();
    void init_TW_T();
    void init_TAB_lst_notes();
    void init_tableWidget_doigts();
    void init_autres();

    void effacer_calque(QGraphicsScene *scene_i, QGraphicsItemGroup *calque_i);

    void set_couleur_bouton(QColor c1, QPushButton *Bt_i);
    void set_couleur_label(QColor c1, QLabel *Lb_i);
    void set_couleur_case(QColor couleur_i, QTableWidget *Tb_i, int L, int C);

    void save_fichier_ini();
    void lecture_fichier_ini();
    int open_fichier_lst();
    void save_fichier_lst();

    void choix_dossier_de_travail();

    int constitue_liste_accords();
    void peuple_liste_mesures();

    void charger_image_manche();

    void affi_txt_en_couleur(int midi_i, QLineEdit *lineEdit_i);

    QString nom_note_FR(int mid);
    QString nom_note_GB(int mid);
    QString nom_octave_GB(int mid);

    int calcul_hauteur_note(int mid1);
    int calcul_midi(int corde_i, int case_i);
    void calcul_xy_note(int corde_i, int case_i, int *x_i, int *y_i);
    int calcul_T_note(int R);
    void detecte_note_xy(int x_i, int y_i, int *corde_i, int *case_i);
    void affiche_details_note(uint midi);

    void dessine_1_note(int corde_i, int case_i, QColor couleur_i);
    void numerote_1_note(int corde_i, int case_i, int num_i);
    void dessine_accord(int corde_i1, int case_i1, int corde_i2, int case_i2);
    void encadre_accord(int case1, int case2);
    void play_note(int i);
    void execute_note_midi(uint midi);
    void joue_1_ligne(int ligne_i);
    void joue_accord_complet(QString ACC, QString cases);
    void complete_accord(int c_min, int c_max);

    void calcul_tps();
    int write_Tableau_vertical();
    void affi_positions_doigts_dans_status(QString s_i);
    void supprime_note(int n);
    void suppression_notes_invalides();
    void affiche_liste_notes();

    //void gestion_mesures();
    void write_Time_line();

    void analyse_notes_importees();

private slots:

    void effacer_touches();
    void on_Bt_RAZ_clicked();

    void Tic2();
    void complete_case(int row, int column, QString s1, QColor c1, QColor c2, bool bold1, QTableWidget *QTI);

    void on_Bt_E3_clicked();
    void on_Bt_F3_clicked();
    void on_Bt_Fd3_clicked();
    void on_Bt_G3_clicked();
    void on_Bt_Gd3_clicked();
    void on_Bt_A3_clicked();
    void on_Bt_Bb3_clicked();
    void on_BT_B3_clicked();

    void on_Bt_C4_clicked();
    void on_Bt_Cd4_clicked();
    void on_Bt_D4_clicked();
    void on_Bt_Eb4_clicked();
    void on_Bt_E4_clicked();
    void on_Bt_F4_clicked();
    void on_Bt_Fd4_clicked();
    void on_Bt_G4_clicked();
    void on_Bt_Gd4_clicked();
    void on_Bt_A4_clicked();
    void on_Bt_Bb4_clicked();
    void on_Bt_B4_clicked();

    void on_Bt_C5_clicked();
    void on_Bt_Cd5_clicked();
    void on_Bt_D5_clicked();
    void on_Bt_Eb5_clicked();
    void on_Bt_E5_clicked();
    void on_Bt_F5_clicked();
    void on_Bt_Fd5_clicked();
    void on_Bt_G5_clicked();
    void on_Bt_Gd5_clicked();
    void on_Bt_A5_clicked();
    void on_Bt_Bb5_clicked();
    void on_Bt_B5_clicked();

    void on_Bt_C6_clicked();
    void on_Bt_Cd6_clicked();
    void on_Bt_D6_clicked();
    void on_Bt_Eb6_clicked();
    void on_Bt_E6_clicked();
    void on_Bt_F6_clicked();
    void on_Bt_Fd6_clicked();
    void on_Bt_G6_clicked();
    void on_Bt_Gd6_clicked();
    void on_Bt_A6_clicked();
    void on_Bt_Bb6_clicked();
    void on_Bt_B6_clicked();
    void on_Bt_C7_clicked();

    //int calcul_nb_colonnes_mesure(int debut_mesure);

    void trace_rectangle1(int x, int y, int dx, int dy);
    void trace_rectangle2(int x, int y, int dx, int dy);
    void trace_ligne_V(int num_colonne, int num_mesure);
    void encadrement_colonne();
    void encadrement_ligne();
    void TW_T_scroll(int H);
    void TW_3_scroll(int H);

    void on_Bt_ACCORD_1_clicked();
    void on_Bt_ACCORD_2_clicked();
    void on_Bt_ACCORD_3_clicked();


    void on_spinBox_2_valueChanged(int arg1);

    //void on_pushButton_clicked();
    void on_Bt_save_clicked();
    void on_pushButton_2_clicked();


    void joue_morceau_debut();
    void joue_morceau_ici(int R, int nb_notes);
    void on_Bt_lecture_1_clicked();
    void on_Bt_lecture_2_clicked();
    void play_toc();

    QString extraction_data(QString s_i, QString label);
    int dechiffre_note(QString label_i, int L, int c);

   // void flip_mesure();

    void create_100_lignes_V();

    void complete_ligne(int R);
    void on_Bt_AddLine_ici_clicked();
    void on_Bt_Supp_line_clicked();

    void on_Bt_refresh_clicked();

    void on_radioButton_Z2_clicked();
    void on_radioButton_Z1_clicked();
    void set_zoom1();
    void set_zoom2();

    void on_Bt_Load_lst_clicked();

    void import_fichier_NOTES();

    void on_Bt_open_dossier_clicked();
    void on_Bt_AddLine_clicked();

    void on_tableWidget_3_cellClicked(int row, int column);

    void on_spinBox_4_valueChanged(int arg1);
    void on_spinBox_5_valueChanged(int arg1);
    void on_Bt_copie_doigts_to_TW3_clicked();

    void on_Bt_STOP_clicked();
    void on_Bt_NO_ACCORD_clicked();

    void on_pushButton_3_clicked();
    void on_pushButton_3b_clicked();
    void on_pushButton_3c_clicked();
    void on_pushButton_3d_clicked();
    void on_pushButton_3e_clicked();

    void on_pushButton_4_clicked();
    //void on_pushButton_5_clicked();
    void on_pushButton_6_clicked();
    void on_tableWidget_doigts_cellClicked(int row, int column);
    void on_Bt_RAZ_doigts_clicked();
    void on_pushButton_7_clicked();
    void on_pushButton_8_clicked();
    void on_pushButton_9_clicked();
   // void on_tableWidget_3_currentCellChanged(int currentRow, int currentColumn, int previousRow, int previousColumn);
    void on_pushButton_10_clicked();
    void on_Bt_import_notes_clicked();

    void on_pushButton_3a_clicked();
    void on_pushButton_11_clicked();
    void on_pushButton_12_clicked();

    void on_tableWidget_3_cellChanged(int row, int column);
    void on_Bt_choix_current_dir_clicked();
    void on_Bt_lecture_3_clicked();
    void on_Bt_save_ACD_clicked();
    int on_Bt_load_ACD_clicked();
    void on_Bt_calcul_tps_clicked();

    void on_Bt_sigle_1_clicked();
    void on_Bt_sigle_2_clicked();
    void on_Bt_sigle_3_clicked();
    void on_Bt_sigle_4_clicked();
    void on_Bt_sigle_9_clicked();
    void on_Bt_sigle_10_clicked();


    void on_Bt_sigle_5_clicked();

    void on_pushButton_clicked();

private:
    Ui::MainWindow *ui;

    //QAction *deposer_noteAct;

    QGraphicsScene *scene1;
    QGraphicsItemGroup *calque_notes;
    QGraphicsItemGroup *calque_encadrement;

    QGraphicsEllipseItem *ellipse1;
    QGraphicsEllipseItem *ellipse2; // centre des notes (pour indiquer les accords)
    QGraphicsRectItem *rectangle1;
    QGraphicsSimpleTextItem *textItem1;

    QFrame *Frame_wWidget1;

    //QGraphicsLineItem *lineItem1;

    QMediaPlayer *player1;
    QMediaPlayer *player2;
    QMediaPlayer *player3;
    QMediaPlayer *player4;
    QMediaPlayer *player5;
    QMediaPlayer *player6;
    QMediaPlayer *player7;
    QMediaPlayer *player8;

    QAudioOutput  *audioOutput1;
    QAudioOutput  *audioOutput2;
    QAudioOutput  *audioOutput3;
    QAudioOutput  *audioOutput4;
    QAudioOutput  *audioOutput5;
    QAudioOutput  *audioOutput6;
    QAudioOutput  *audioOutput7;
    QAudioOutput  *audioOutput8;


    QTimer *Timer2;
    QEvent *event1;

    QList<QFrame *> lst_frames;

    QFrame *line1;

};
#endif // MainWindow_H
